/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20230521

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "gram.y"
#include <stdlib.h>
#include <string.h>

#include "sc.h"
#include "cmds/cmds.h"
#include "interp.h"
#include "macros.h"
#include "actions/sort.h"
#include "actions/filter.h"
#include "maps.h"
#include "marks.h"
#include "xmalloc.h" /* for scxfree*/
#include "actions/hide_show.h"
#include "cmds/cmds_normal.h"
#include "conf.h"
#include "pipe.h"
#include "main.h"
#include "file.h"
#include "tui.h"
#include "undo.h"
#include "yank.h"
#include "graph.h"
#include "utils/dictionary.h"
#include "trigger.h"
#include "actions/shift.h"
#include "clipboard.h"
#include "actions/plot.h"
#include "actions/subtotal.h"
#include "actions/freeze.h"
#include "sheet.h"
#include "vmtbl.h"
#include "cmds/cmds_command.h"

void yyerror(char *err);               /* error routine for yacc (gram.y)*/
int yylex();
extern struct session * session;

#ifdef USELOCALE
#include <locale.h>
#endif

#ifndef MSDOS
#include <unistd.h>
#endif

#define ENULL (struct enode *) 0
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 50 "gram.y"
typedef union YYSTYPE {
    int ival;
    double fval;
    struct ent_ptr ent;
    struct enode * enode;
    char * sval;
    struct range_s rval;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 87 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define STRING 257
#define COL 258
#define NUMBER 259
#define FNUMBER 260
#define RANGE 261
#define VAR 262
#define WORD 263
#define MAPWORD 264
#define PLUGIN 265
#define S_SHOW 266
#define S_HIDE 267
#define S_SHOWROW 268
#define S_HIDEROW 269
#define S_SHOWCOL 270
#define S_HIDECOL 271
#define S_FREEZE 272
#define S_UNFREEZE 273
#define S_MARK 274
#define S_AUTOFIT 275
#define S_PAD 276
#define S_DELETECOL 277
#define S_DATEFMT 278
#define S_SUBTOTAL 279
#define S_RSUBTOTAL 280
#define S_FORMAT 281
#define S_FMT 282
#define S_LET 283
#define S_LABEL 284
#define S_LEFTSTRING 285
#define S_RIGHTSTRING 286
#define S_LEFTJUSTIFY 287
#define S_RIGHTJUSTIFY 288
#define S_CENTER 289
#define S_SORT 290
#define S_FILTERON 291
#define S_GOTO 292
#define S_GOTOB 293
#define S_CCOPY 294
#define S_CPASTE 295
#define S_PLOT 296
#define S_LOCK 297
#define S_UNLOCK 298
#define S_DEFINE 299
#define S_UNDEFINE 300
#define S_DETAIL 301
#define S_EVAL 302
#define S_SEVAL 303
#define S_ERROR 304
#define S_FILL 305
#define S_STRTONUM 306
#define S_DELETEROW 307
#define S_VALUEIZEALL 308
#define S_SHIFT 309
#define S_GETNUM 310
#define S_YANKAREA 311
#define S_PASTEYANKED 312
#define S_GETSTRING 313
#define S_GETEXP 314
#define S_GETFMT 315
#define S_GETFORMAT 316
#define S_RECALC 317
#define S_EXECUTE 318
#define S_QUIT 319
#define S_EXPORT 320
#define S_REBUILD_GRAPH 321
#define S_PRINT_GRAPH 322
#define S_SYNCREFS 323
#define S_REDO 324
#define S_UNDO 325
#define S_IMAP 326
#define S_EMAP 327
#define S_CMAP 328
#define S_NEWSHEET 329
#define S_NEXTSHEET 330
#define S_PREVSHEET 331
#define S_DELSHEET 332
#define S_MOVETOSHEET 333
#define S_RENAMESHEET 334
#define S_NMAP 335
#define S_VMAP 336
#define S_INOREMAP 337
#define S_ENOREMAP 338
#define S_CNOREMAP 339
#define S_NNOREMAP 340
#define S_VNOREMAP 341
#define S_NUNMAP 342
#define S_IUNMAP 343
#define S_EUNMAP 344
#define S_CUNMAP 345
#define S_VUNMAP 346
#define S_COLOR 347
#define S_CELLCOLOR 348
#define S_UNFORMAT 349
#define S_REDEFINE_COLOR 350
#define S_DEFINE_COLOR 351
#define S_SET 352
#define S_FCOPY 353
#define S_FSUM 354
#define S_TRIGGER 355
#define S_UNTRIGGER 356
#define S_OFFSCR_SC_COLS 357
#define S_OFFSCR_SC_ROWS 358
#define S_NB_FROZEN_ROWS 359
#define S_NB_FROZEN_COLS 360
#define S_NB_FROZEN_SCREENROWS 361
#define S_NB_FROZEN_SCREENCOLS 362
#define K_AUTOBACKUP 363
#define K_NOAUTOBACKUP 364
#define K_AUTOCALC 365
#define K_NOAUTOCALC 366
#define K_DEBUG 367
#define K_NODEBUG 368
#define K_TRG 369
#define K_NOTRG 370
#define K_EXTERNAL_FUNCTIONS 371
#define K_NOEXTERNAL_FUNCTIONS 372
#define K_EXEC_LUA 373
#define K_NOEXEC_LUA 374
#define K_HALF_PAGE_SCROLL 375
#define K_NOHALF_PAGE_SCROLL 376
#define K_NOCURSES 377
#define K_CURSES 378
#define K_NUMERIC 379
#define K_NONUMERIC 380
#define K_NUMERIC_DECIMAL 381
#define K_NONUMERIC_DECIMAL 382
#define K_NUMERIC_ZERO 383
#define K_NONUMERIC_ZERO 384
#define K_OVERLAP 385
#define K_NOOVERLAP 386
#define K_INPUT_BAR_BOTTOM 387
#define K_IGNORE_HIDDEN 388
#define K_NOIGNORE_HIDDEN 389
#define K_INPUT_EDIT_MODE 390
#define K_UNDERLINE_GRID 391
#define K_TRUNCATE 392
#define K_NOTRUNCATE 393
#define K_AUTOWRAP 394
#define K_NOAUTOWRAP 395
#define K_QUIET 396
#define K_NOQUIET 397
#define K_QUIT_AFTERLOAD 398
#define K_NOQUIT_AFTERLOAD 399
#define K_XLSX_READFORMULAS 400
#define K_NOXLSX_READFORMULAS 401
#define K_DEFAULT_COPY_TO_CLIPBOARD_CMD 402
#define K_DEFAULT_PASTE_FROM_CLIPBOARD_CMD 403
#define K_COPY_TO_CLIPBOARD_DELIMITED_TAB 404
#define K_NOCOPY_TO_CLIPBOARD_DELIMITED_TAB 405
#define K_COPY_TO_CLIPBOARD_WYSIWYG 406
#define K_NOCOPY_TO_CLIPBOARD_WYSIWYG 407
#define K_DEFAULT_OPEN_FILE_UNDER_CURSOR_CMD 408
#define K_IMPORT_DELIMITED_TO_TEXT 409
#define K_IGNORECASE 410
#define K_NOIGNORECASE 411
#define K_TM_GMTOFF 412
#define K_COMMAND_TIMEOUT 413
#define K_MAPPING_TIMEOUT 414
#define K_NEWLINE_ACTION 415
#define K_SHOW_CURSOR 416
#define K_NOSHOW_CURSOR 417
#define K_ERROR 418
#define K_INVALID 419
#define K_FIXED 420
#define K_SUM 421
#define K_PROD 422
#define K_AVG 423
#define K_STDDEV 424
#define K_COUNT 425
#define K_ROWS 426
#define K_COLS 427
#define K_ABS 428
#define K_FROW 429
#define K_FCOL 430
#define K_ACOS 431
#define K_ASIN 432
#define K_ATAN 433
#define K_ATAN2 434
#define K_CEIL 435
#define K_COS 436
#define K_EXP 437
#define K_FABS 438
#define K_FLOOR 439
#define K_HYPOT 440
#define K_LN 441
#define K_LOG 442
#define K_PI 443
#define K_POW 444
#define K_SIN 445
#define K_SQRT 446
#define K_TAN 447
#define K_DTR 448
#define K_RTD 449
#define K_MAX 450
#define K_MIN 451
#define K_RND 452
#define K_ROUND 453
#define K_IF 454
#define K_PV 455
#define K_FV 456
#define K_PMT 457
#define K_HOUR 458
#define K_MINUTE 459
#define K_SECOND 460
#define K_MONTH 461
#define K_DAY 462
#define K_YEAR 463
#define K_NOW 464
#define K_DATE 465
#define K_DTS 466
#define K_TTS 467
#define K_FMT 468
#define K_REPLACE 469
#define K_SUBSTR 470
#define K_UPPER 471
#define K_LOWER 472
#define K_CAPITAL 473
#define K_STON 474
#define K_SLEN 475
#define K_EQS 476
#define K_EXT 477
#define K_EVALUATE 478
#define K_SEVALUATE 479
#define K_LUA 480
#define K_NVAL 481
#define K_SVAL 482
#define K_LOOKUP 483
#define K_HLOOKUP 484
#define K_VLOOKUP 485
#define K_INDEX 486
#define K_STINDEX 487
#define K_GETENT 488
#define K_TBLSTYLE 489
#define K_TBL 490
#define K_LATEX 491
#define K_SLATEX 492
#define K_TEX 493
#define K_FRAME 494
#define K_RNDTOEVEN 495
#define K_FILENAME 496
#define K_MYROW 497
#define K_MYCOL 498
#define K_LASTROW 499
#define K_LASTCOL 500
#define K_COLTOA 501
#define K_CRACTION 502
#define K_CRROW 503
#define K_CRCOL 504
#define K_ROWLIMIT 505
#define K_COLLIMIT 506
#define K_PAGESIZE 507
#define K_ERR 508
#define K_REF 509
#define K_LOCALE 510
#define K_SET8BIT 511
#define K_ASCII 512
#define K_CHR 513
#define K_FACT 514
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    8,    8,    3,    3,    1,    1,
    1,    1,    1,    1,    4,    4,    2,    2,    2,    2,
    5,    5,    9,    9,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,
};
static const YYINT yylen[] = {                            2,
    4,    3,    4,    4,    4,    2,    2,    2,    3,    3,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    4,    4,    4,    4,    1,    3,    3,    4,    4,
    5,    4,    3,    4,    2,    4,    2,    4,    2,    4,
    2,    3,    5,    5,    4,    2,    5,    3,    3,    2,
    5,    3,    2,    3,    2,    2,    2,    3,    3,    2,
    2,    3,    3,    2,    2,    1,    2,    2,    2,    2,
    1,    1,    1,    2,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    2,    2,    2,    2,    2,
    2,    2,    3,    3,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    1,    5,    5,    1,    2,    1,    3,
    2,    3,    3,    2,    2,    2,    3,    1,    1,    1,
    1,    1,    1,    1,    2,    6,    2,    2,    2,    7,
    6,    2,    2,    0,    1,    1,    5,    3,    5,    5,
    7,    5,    7,    5,    7,    5,    7,    5,    7,    5,
    7,    7,    5,    7,    7,    5,    5,    5,    5,    5,
    5,    5,    5,    7,    5,    5,    5,    5,    5,    7,
    5,    5,    7,    5,    5,    5,    5,    5,    5,    7,
    9,    9,    9,    9,    5,    5,    5,    5,    5,    5,
    2,    9,    5,    9,    5,    5,    7,    5,    7,    7,
    5,    5,    5,    7,    7,    9,    7,    7,    9,    9,
    9,    9,    7,    7,    9,    7,    7,    2,    2,    2,
    2,    7,    7,    9,    5,    5,    9,    3,    2,    1,
    1,    2,    1,    2,    2,    5,    5,    5,    5,    5,
    2,    1,    2,    1,    5,    3,    3,    3,    3,    3,
    2,    3,    1,    5,    3,    3,    3,    3,    3,    3,
    4,    4,    4,    3,    1,    3,    3,    1,    2,    3,
    3,    4,    7,    1,    1,    1,    1,    1,    2,    2,
    1,    1,    0,    2,    3,    1,    3,    1,    3,    1,
    3,    1,    1,    3,    1,    1,    3,    1,    1,    3,
    1,    1,    3,    1,    1,    3,    1,    1,    3,    1,
    1,    3,    1,    1,    3,    1,    1,    3,    1,    1,
    3,    1,    3,    1,    1,    1,    3,    1,    1,    3,
    1,    1,    3,    1,    1,    3,    1,    1,    3,    1,
    1,    3,    1,    1,    3,    1,    1,    3,    3,    3,
    1,    3,    1,    3,    1,    1,    3,    1,    3,    3,
    1,    3,    1,    3,    1,    3,    3,    1,    1,
};
static const YYINT yydefred[] = {                         0,
  135,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   26,    0,    0,    0,    0,    0,    0,
    0,    0,  124,    0,  118,    0,  119,  120,  121,  123,
  122,    0,    0,    0,    0,   72,   73,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  283,    0,  109,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   14,
   15,   12,   13,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   16,   11,    0,  268,  274,    0,
    0,    0,  275,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    6,    7,    8,    0,   53,   57,
  277,  278,    0,    0,    0,    0,   56,    0,   61,    0,
    0,   60,   64,    0,   67,   68,  281,  282,    0,  114,
   92,  233,    0,  231,  242,  244,    0,    0,    0,    0,
    0,    0,    0,  136,    0,  253,    0,  133,    0,    0,
   65,   17,    0,    0,  125,    0,    0,  127,  128,  129,
   50,  116,    0,    0,    0,    0,   69,   70,   74,   75,
    0,    0,    0,    0,    0,    0,    0,   86,   87,   88,
   90,   89,   91,  102,    0,  103,    0,    0,    0,  108,
    0,  101,   95,   96,   97,   98,   99,  100,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   49,  269,    0,    0,    0,    0,   10,    0,    0,    0,
   52,    9,    0,    0,    0,    0,   42,  280,  279,   58,
   59,   54,   62,   63,  110,    0,  112,    0,  235,  229,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  191,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  218,  219,  220,  221,    0,  241,  243,    0,    0,
    0,    0,    0,    0,  234,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   33,
    0,   27,    0,    0,    0,  117,   77,   78,   80,   76,
   79,   82,   83,   85,   81,   84,   93,    0,    0,    0,
  301,    0,  304,    0,  307,    0,  310,    0,  313,    0,
  316,    0,  319,    0,  334,    0,  337,    0,  343,    0,
  346,    0,  293,    0,    0,  322,    0,    0,    0,  296,
    0,  299,    0,  325,    0,  328,    0,  331,    0,    0,
    0,  355,    0,  358,    0,    0,    0,  340,    0,    0,
    0,    0,    0,  369,  284,   94,   23,   25,   22,   24,
   36,   34,   40,   38,    0,   29,   45,    0,  271,    0,
  270,    0,  267,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  138,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  228,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  252,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   31,   47,    0,  272,   43,   44,   51,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  105,  106,  300,  303,
  306,  309,  312,  315,  318,  333,  336,  342,  345,  285,
  287,  321,  289,  291,  294,  297,  323,  327,  330,  349,
  350,  354,  357,  359,  352,  339,  366,  362,  364,  360,
  348,  367,    0,  193,  137,    0,  140,    0,  142,    0,
  144,    0,  146,    0,  148,  156,  157,  158,  159,  160,
  161,  162,  163,    0,  165,  166,  167,  168,  169,    0,
  171,  172,    0,  174,  175,  176,  177,  178,    0,  150,
    0,    0,  153,    0,  179,    0,    0,    0,    0,    0,
  185,  186,  187,  188,  189,  190,  198,    0,    0,    0,
    0,    0,    0,  201,  202,  203,  195,  196,    0,    0,
  225,  226,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  236,  237,  239,  238,  240,
  245,  139,    0,  126,    0,  131,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  130,  273,  141,  143,
  145,  147,  149,  164,  170,  173,  151,  152,    0,  154,
  155,  180,    0,    0,    0,    0,  199,    0,    0,  200,
    0,    0,  197,  216,  217,  222,  223,  207,  208,    0,
    0,    0,    0,  204,    0,  205,  213,    0,  214,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  181,  182,  183,  184,  192,  194,
  224,  227,  209,  210,  211,  212,  206,  215,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  256,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  516,  258,
  259,  258,  259,  259,  259,  258,  258,  258,  259,  258,
  259,  258,  258,  259,  258,  257,  258,  261,  262,   64,
   36,  517,  519,  520,  517,  519,  519,  258,  259,  520,
  520,  520,  520,  520,  520,  520,  520,  519,  519,  257,
  259,  260,   43,   45,   35,   37,  518,  520,  257,   35,
   37,  518,  519,  257,  520,  520,  257,  517,  521,  520,
  517,  257,  259,  260,  508,  509,   33,   43,   45,  123,
   64,   40,  126,  517,  522,  523,  522,  257,  518,  520,
  519,  259,  520,  123,  520,  123,  123,  520,  520,  520,
  258,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  520,  520,  257,  257,  525,  521,
  520,  520,  259,  259,  259,  259,  259,  259,   58,   58,
   58,   58,   58,   58,   58,   58,  257,  520,   58,  258,
  520,  259,   36,  488,  258,   58,  257,  258,  258,  259,
  259,  257,   61,   61,   61,   61,  257,  518,  518,  257,
  257,  520,  257,  257,  520,  517,  519,   46,  523,  523,
  522,  257,  420,  421,  422,  423,  424,  425,  426,  427,
  428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
  438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
  458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
  496,  497,  498,  499,  500,  501,  508,  509,  511,  512,
  513,  514,   64,  522,  523,   59,   63,  124,   38,   60,
   61,   62,   43,   45,   35,   42,   47,   37,   94,  518,
  518,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  259,  259,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
  414,  415,  416,  417,  526,  257,  259,  259,  258,  258,
  258,  259,  258,  259,  520,  520,  258,   58,  259,   40,
  259,   36,  517,  257,  257,  259,  522,  522,  522,  522,
  259,  125,  523,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,  420,   41,  522,  522,  522,  522,
   61,   62,  522,  522,   61,  522,  522,  522,  522,  522,
  522,  522,  522,  518,  125,  125,  125,  259,  259,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   61,   61,  520,  258,  522,  259,  258,  258,  259,   46,
   33,  519,  520,  519,  520,  519,  520,  519,  520,  519,
  520,  520,  520,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,  517,  519,  520,  522,  519,  520,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  517,  519,  522,  519,  522,  519,  522,  519,  522,
  519,  522,  522,  522,  522,  522,  522,  522,   41,   58,
  522,  522,  522,   33,   33,  259,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  521,
  521,  259,  259,  521,  259,  259,  518,  518,  518,  259,
  263,  259,   44,  259,  517,   44,   41,   44,   41,   44,
   41,   44,   41,   44,   41,   41,   41,   41,   41,   41,
   41,   41,   41,   44,   41,   41,   41,   41,   41,   44,
   41,   41,   44,   41,   41,   41,   41,   41,   44,   41,
   44,   44,   41,   44,   41,   44,   44,   44,   44,   44,
   41,   41,   41,   41,   41,   41,   41,   44,   44,   44,
   44,   44,   44,   41,   41,   41,   41,   41,   44,   44,
   41,   41,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   41,   41,   41,   41,   41,
   41,  523,  522,  520,  520,  257,  522,  522,  522,  522,
  522,  522,  522,  522,  522,  522,  522,  524,  522,  524,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,  522,  522,  522,  519,  522,  519,
  522,  519,  522,  519,  522,  519,  257,   41,   41,   41,
   41,   41,   41,   41,   41,   41,   41,   41,   44,   41,
   41,   41,   44,   44,   44,   44,   41,   44,   44,   41,
   44,   44,   41,   41,   41,   41,   41,   41,   41,   44,
   44,   44,   44,   41,   44,   41,   41,   44,   41,  522,
  522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
  522,  522,  522,  522,   41,   41,   41,   41,   41,   41,
   41,   41,   41,   41,   41,   41,   41,   41,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                         99,
  174,  147,  123,  124,  159,  847,  176,  848,  219,  445,
};
static const YYINT yysindex[] = {                      3400,
    0, -240, -186, -257, -248, -244, -227, -162, -139, -223,
 -217, -213, -207,  -26,   30,   30, -133,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,  -20,  -13,   30,
    0, -204,   30,   30,  132,   30,   77,  312,  312, -200,
   -9,   30, -198,    0,   30,    1,  -64,  -60,   30,   30,
   30, -182,    0, -179,    0, -175,    0,    0,    0,    0,
    0, -153, -145, -136, -120,    0,    0, -118, -115, -111,
 -110, -106, -104, -102,  -99,  -98,  -88,  -83,  -75,  -72,
  -71,  -68,  -67,  109,   30,  -58,  -57,    0,  132,    0,
   30,   30,  -56,  -54,  -52,  -51,  -50,  -49,    0,    0,
    0,    0,    0,  144,  153,  154,  156,  162,  163,  165,
  170,  116,  187,   39,    0,    0,  -29,    0,    0, -233,
  -10,  199,    0,    3,  199,   10,   20,   -1,   21,   22,
  220,  221,  222,  224,    0,    0,    0,   29,    0,    0,
    0,    0,   17,   17,   32,   36,    0,   30,    0,   37,
   38,    0,    0,   30,    0,    0,    0,    0,   30,    0,
    0,    0,  252,    0,    0,    0,  771,  771,  312,   42,
 3343,  682,  771,    0, 6745,    0, 6745,    0,   17,   17,
    0,    0,   47,   49,    0,   51,   52,    0,    0,    0,
    0,    0,   53,   57,   59,   75,    0,    0,    0,    0,
   76,   79,   81,   83,   85,   86,   90,    0,    0,    0,
    0,    0,    0,    0,   92,    0,   91,   94, 6536,    0,
   97,    0,    0,    0,    0,    0,    0,    0,   99,  100,
   93,   98,  103,  110,  104,  113,   30,   30,  117,  -30,
    0,    0,  123,  320,  -16,   77,    0,  111,  126,  125,
    0,    0,  312,  312,  312,  312,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  199,    0,  127,    0,    0,
  101,  260,  771,  347,  348,  351,  352,  353,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,    0,  372,  373,  374,  375,
  376,  377,  385,  386,  388,  389,  390,  391,  392,  393,
  394,  396,  397,  399,  400,  401,    0,  402,  469,  470,
  472,  478,  479,  481,  483,  486,  493,  496,  497,  498,
  511,  512,  513,  514,  515,  516,  517,  524,  525,  526,
  533,    0,    0,    0,    0,  535,    0,    0,  543,  544,
  545,  546, 3438, 3958,    0,  312,  312,  312,  312,    7,
  312,  161,  312,  312,  312,  312,  312,  312,  312,    0,
   17,    0,  462,  463,  468,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  268,  335,  534,
    0,  537,    0,  547,    0,  548,    0,  549,    0,  551,
    0,  552,    0,  553,    0,  554,    0,  564,    0,  565,
    0,  567,    0,  568,  574,    0,  580,  581,  585,    0,
  592,    0,  593,    0,  594,    0,  598,    0,  602,  604,
  612,    0,  613,    0,  616,  617,  619,    0,  626,  627,
  630,  632,  634,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   30,    0,    0,  338,    0,  312,
    0,  384,    0,  349,  434,  437, 6745, 6745, 6745, 6745,
  560,  664,    0,   30,   30,   30,   30,   30,   30,   30,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  301,  301,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  301,  301,  301,  301,  301,  312,  312,
  312,  312,  312,  312,  755,    0, 6745, 3987, 3546, 3568,
  312,  312,  270,  270,  312,  270,  101,  101,  101,  605,
  605,  605,    0,    0,  665,  667,  442,  443,  444,  445,
  447,  448,  450,  452,  460,  465,  471,  474,  475,  477,
  480,  484,  494,  495,  499,  500,  507,  508,  509,  520,
  132,  132,  522,  528,  132,  530,  538,   17,   17,   17,
 -251,  540,    0,    0, 4024,    0,    0,    0,    0,  541,
   77,  677,  688,  687,  699,  701,  715,  713,  732,  739,
  744,  751,  752, 4053, 4082, 4093, 4122, 4151, 4162, 4191,
 4220, 4231, 4260, 4289, 4300, 4329, 4358, 4369, 4398, 4427,
 4438, 4467, 4496, 4507,  199,  750,  760, 4536,  758,  765,
 4565, 4576, 4605, 4634, 4671, 4700, 4729, 4740, 4769, 4798,
 4809, 4838, 4867,  487, 4904, 4933, 4962, 4973, 5002, 5031,
 5042, 5071, 5100, 5111, 5140, 5169, 5180, 5209, 5238, 5275,
 5304,  199,  769, 5333,  772, 5344,  773, 5373,  778, 5402,
  779, 5439, 5468, 5497, 5508, 5537, 5566, 5577,  771,  312,
  270,  270,  270,   30,   30,  569,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  312,    0,    0,  312,    0,  312,    0,  312,
    0,  312,    0,  312,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  312,    0,    0,    0,    0,    0,  312,
    0,    0,  312,    0,    0,    0,    0,    0,  312,    0,
  312,  312,    0,  312,    0,  312,  312,  312,  312,  312,
    0,    0,    0,    0,    0,    0,    0,  312,  312,  312,
  312,  312,  312,    0,    0,    0,    0,    0,  312,  312,
    0,    0,  312,  312,  312,  312,   30,  312,   30,  312,
   30,  312,   30,  312,   30,    0,    0,    0,    0,    0,
    0,    0, 6774,    0,  570,    0, 5606, 5635, 5646, 5675,
 5704, 5715, 5744, 5773, 5784, 5813, 6745,  -15, 5842,   -2,
 5853, 5882, 5911, 5948, 5977, 6006, 6017, 6046, 6075, 6112,
 6141, 6170, 6181, 6210, 6239, 6250, 6279,  783, 6308,  781,
 6345,  786, 3308,  795, 3918,  797,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  312,    0,
    0,    0,  312,  312,  312,  312,    0,  312,  312,    0,
  312,  312,    0,    0,    0,    0,    0,    0,    0,  312,
  312,  312,  312,    0,  312,    0,    0,  312,    0, 6745,
 6374, 6403, 6414, 6443, 6472, 6483, 6512, 6541, 6552, 6581,
 6610, 6621, 6650, 6679,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                       839,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  840,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  841,    0,    0,    0,  842,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  843,  844,  845,  850,  852,  854,  859,
  862,    0,  865,    0,    0,    0,    0,    0,    0,    0,
    0,   13,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  866,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3337,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  867,    0,  868,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  869,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  870,    0,  871,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  876,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  879,    0,    0,    0,    0,
  589,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  582,    0,  671,    0,  728,    0,  829,    0,  918,
    0, 1000,    0, 1089,    0, 1146,    0, 1247,    0, 1336,
    0, 1418,    0, 1507, 1564,    0, 1665, 1754, 1836,    0,
 1925,    0, 1982,    0, 2083,    0, 2172,    0,    0,    0,
 2254,    0, 2343,    0,    0, 2400, 2501,    0, 2590, 2672,
 2761, 2818, 2919,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  883,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  885,  887,  889,  891,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  140,    0,  631,  679,
    0,    0,  774,  790,    0, 3462,  623, 3473, 3502, 3366,
 3405, 3434,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  851,    0,  851,    0,  851,    0,  851,    0,  851,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3929,  851,    0,    0,  851,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 6716,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3510, 3512, 3541,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   64,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    4,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   26,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
   65,   -8,  102,  142,  -84,  -38, -164,  112,    0,    0,
};
#define YYTABLESIZE 6953
static const YYINT yytable[] = {                        175,
  177,  104,  269,  270,  220,  243,  243,  740,  355,  121,
  105,  741,  276,  106,  145,  121,  146,  100,  101,  462,
  152,  150,  143,  151,  144,  888,  121,  458,  889,  143,
  107,  144,  179,  143,  112,  144,  121,  120,  891,  167,
  113,  889,  121,  120,  265,  114,  172,  265,  276,  168,
  115,  169,  154,  276,  120,  276,  178,  276,  186,  143,
  182,  144,  187,  254,  120,  121,  266,  551,  552,  266,
  171,  102,  103,  276,  121,  191,  276,  192,  122,  125,
  125,  193,  122,  122,  122,  122,  122,  122,  122,  122,
  125,  125,  122,  120,  125,  108,  109,  122,  122,  158,
  122,  161,  120,  194,  254,  122,  125,  254,  473,  122,
  122,  195,  121,  122,  122,  122,  126,  127,  110,  111,
  196,  254,  254,  184,  128,  129,  254,  138,  139,  170,
  271,  153,  173,  354,  258,  259,  197,  368,  198,  255,
  120,  199,  366,  181,  121,  200,  201,  367,  122,  122,
  202,  121,  203,  158,  204,  122,  122,  205,  206,  130,
  131,  132,  133,  134,  135,  136,  137,  121,  207,  148,
  370,  371,  120,  208,  155,  156,  122,  160,  122,  120,
  255,  209,  180,  255,  210,  211,  183,  185,  212,  213,
  188,  189,  190,  167,  369,  120,  121,  255,  217,  218,
  172,  229,  223,  168,  224,  169,  225,  226,  227,  228,
  230,  231,  122,  232,  467,  468,  469,  470,  122,  233,
  234,  555,  235,  266,  171,  215,  216,  236,  242,  242,
  116,  117,  221,  222,  118,  119,  140,  117,  141,  142,
  118,  119,  461,  149,  239,  141,  142,  245,  117,  141,
  142,  118,  119,  238,  244,  241,  246,  250,  117,  247,
  267,  118,  119,  162,  117,  163,  164,  248,  119,  276,
  276,  276,  276,  276,  276,  141,  142,  249,  252,  251,
  253,  254,  255,  170,  256,  257,  173,  117,  260,  262,
  118,  119,  261,  263,  264,  265,  240,  268,  272,  118,
  119,  122,  122,  372,  365,  373,  368,  374,  375,  376,
  463,  366,  363,  377,  364,  378,  367,  547,  548,  549,
  550,  553,  554,  556,  557,  558,  559,  560,  561,  562,
  563,  379,  380,  167,  117,  381,  121,  382,  119,  383,
  172,  384,  385,  168,  167,  169,  386,  121,  387,  388,
  449,  172,  389,  446,  168,  450,  169,  447,  448,  460,
  451,  453,  564,  369,  171,  214,  117,  464,  452,  118,
  119,  454,  237,  117,  457,  171,  118,  119,  455,  456,
  473,  459,  465,  466,  472,  471,  474,  475,  157,  117,
  476,  477,  478,  119,  479,  480,  481,  482,  483,  484,
  485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
  495,  496,  497,  498,  499,  500,  501,  162,  117,  163,
  164,  605,  119,  170,  502,  503,  173,  504,  505,  506,
  507,  508,  509,  510,  170,  511,  512,  173,  513,  514,
  515,  516,  624,  625,  626,  627,  628,  629,  630,  631,
  632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
  642,  643,  644,  648,  651,  652,  653,  654,  655,  656,
  657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
  667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
  677,  678,  679,  680,  681,  684,  686,  688,  690,  692,
  693,  694,  695,  696,  697,  698,  730,  731,  517,  518,
  734,  519,  701,  702,  165,  166,  703,  520,  521,  122,
  522,  365,  523,  368,  359,  524,  568,  797,  366,  363,
  798,  364,  525,  367,  832,  526,  527,  528,  122,  122,
  122,  122,  122,  122,  122,  356,  360,  361,  362,  357,
  529,  530,  531,  532,  533,  534,  535,  162,  117,  163,
  164,  118,  119,  536,  537,  538,  645,  645,  162,  117,
  163,  164,  539,  119,  540,  612,  614,  616,  618,  620,
  369,  302,  541,  542,  543,  544,  565,  566,  251,  737,
  738,  739,  567,  569,  570,  604,  603,  571,  682,  682,
  682,  682,  682,  646,  649,  610,  607,  572,  573,  574,
  358,  575,  576,  577,  578,  613,  615,  617,  619,  621,
  622,  623,  246,  251,  579,  580,  251,  581,  582,  251,
  260,  251,  251,  251,  583,  683,  685,  687,  689,  691,
  584,  585,  606,  647,  650,  586,  251,  251,  251,  251,
  251,  251,  587,  588,  589,  158,  158,  246,  590,  158,
  246,  833,  591,  246,  592,  246,  246,  246,  165,  166,
  305,  260,  593,  594,  260,  745,  595,  596,  259,  597,
  246,  246,  246,  246,  246,  246,  598,  599,  260,  260,
  600,  608,  601,  260,  602,  609,  611,  704,  369,  705,
  706,  707,  708,  709,  837,  710,  711,  838,  712,  839,
  713,  840,  251,  841,  167,  842,  259,  121,  714,  259,
  746,  172,  259,  715,  168,  843,  169,  308,  747,  716,
  748,  844,  717,  718,  845,  719,  259,  259,  720,  749,
  846,  259,  721,  849,  750,  353,  246,  851,  852,  853,
  854,  855,  722,  723,  260,  751,  752,  724,  725,  856,
  857,  858,  859,  860,  861,  726,  727,  728,  122,  122,
  862,  863,  753,  256,  864,  865,  866,  867,  729,  869,
  732,  871,  754,  873,  755,  875,  733,  167,  735,  257,
  121,  756,  757,  779,  172,  699,  736,  168,  742,  744,
  780,  782,  259,  167,  170,  783,  121,  173,  165,  166,
  172,  256,  816,  168,  256,  818,  820,  256,  171,  165,
  166,  822,  824,  909,  911,  836,  877,  257,  311,  913,
  257,  256,  256,  257,  171,  916,  256,  919,  134,   71,
  104,  107,   21,   20,   19,  834,  835,  257,  257,   18,
  920,   37,  257,   35,  921,  922,  923,  924,   41,  925,
  926,   39,  927,  928,   46,   55,  115,  132,  111,   28,
   48,  929,  930,  931,  932,    2,  933,  170,  113,  934,
  173,  125,   30,  125,    1,  125,    3,  125,    4,  125,
    5,  275,    0,  170,    0,  850,  173,  256,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  257,    0,    0,    0,  314,  868,    0,
  870,    0,  872,    0,  874,    0,  876,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  162,  117,
  163,  164,    0,  119,  302,  302,  302,  302,  302,  302,
  302,  302,  302,  302,  302,  302,  302,  302,  302,  302,
  302,  302,  302,  302,  302,  302,  302,  302,  302,  302,
  302,  302,  302,  302,  302,  302,  302,  302,  302,  302,
  302,  302,  302,  302,  302,  302,  302,  302,  302,  302,
  302,  302,  302,  302,  302,  302,  302,  302,  302,  317,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  162,  117,  163,  164,    0,  119,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  162,  117,  163,
  164,    0,  119,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  305,  305,
  305,  305,  305,  305,  305,  305,  305,  305,  332,    0,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  335,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  165,
  166,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  341,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  165,  166,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  165,  166,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  344,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  317,  317,  317,  317,  317,  317,  317,  317,
  317,  317,  317,  317,  317,  317,  317,  317,  317,  317,
  317,  317,  317,  317,  317,  317,  317,  317,  317,  317,
  317,  317,  317,  317,  317,  317,  317,  317,  317,  317,
  317,  317,  317,  317,  317,  317,  317,  317,  317,  317,
  317,  317,  317,  317,  317,  317,  317,  286,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  332,  332,  332,  332,  332,  332,  332,  332,  332,
  332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
  332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
  332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
  332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
  332,  332,  332,  332,  332,  332,  288,    0,  335,  335,
  335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
  335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
  335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
  335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
  335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
  335,  335,  335,  320,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  290,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  292,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,  286,  295,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  298,    0,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  320,  320,
  320,  324,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  326,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  292,  292,  292,  292,
  292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
  292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
  292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
  292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
  292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
  292,  329,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  295,  295,
  295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
  295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
  295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
  295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
  295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
  295,  295,  295,  353,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  298,  298,  298,
  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
  298,  298,  356,    0,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  351,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  338,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  365,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
  353,  361,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  356,  356,  356,  356,  356,
  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
  363,    0,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  351,  351,  351,
  351,  351,  351,  351,  351,  351,  351,  347,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,  338,  338,
  338,  338,  338,  338,  338,  338,  338,  338,  368,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  365,  365,  365,  365,  365,  365,  365,  365,
  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
  365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
  365,  365,  365,  365,  365,  365,  365,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  361,  361,  361,  361,  361,  361,
  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
  361,  361,  361,  361,  361,  361,  361,  361,  361,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  363,  363,  363,  363,  363,  363,  363,
  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
  363,  363,  363,  363,  363,  363,  363,  363,    0,    0,
  347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  368,  368,  368,  368,  368,  368,  368,  368,  368,
  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
  368,  368,  368,  368,  368,  368,  230,    0,    0,    0,
    0,    0,  365,    0,  368,  359,    0,    0,  914,  366,
  363,  915,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  248,  356,  360,  361,  362,
  357,  230,    0,  230,  230,    0,    0,  230,  230,  230,
  230,  230,    0,  230,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  230,  230,  230,  230,  230,  230,
  248,  369,  248,  248,  249,    0,  248,  248,  248,  248,
  248,    0,  248,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  248,  248,  248,  248,  248,  248,    0,
  230,  358,    0,  250,    0,    0,    0,    0,    0,  249,
    0,  249,  249,    0,    0,  249,  249,  249,  249,  249,
    0,  249,    0,    0,    0,    0,    0,    0,    0,    0,
  230,  258,  249,  249,  249,  249,  249,  249,  250,    0,
  250,  250,  247,    0,  250,  250,  250,  250,  250,    0,
  250,    0,    0,    0,    0,    0,    0,    0,    0,  248,
    0,  250,  250,  250,  250,  250,  250,    0,    0,  258,
    0,  264,  258,    0,    0,  258,    0,  247,    0,  261,
  247,  262,    0,  247,    0,  247,  247,  247,    0,  258,
  258,    0,    0,    0,  258,    0,    0,    0,  249,    0,
  247,  247,  247,  247,  247,  247,  264,    0,    0,  264,
  263,    0,  264,    0,  264,  264,  264,  261,    0,  262,
  261,    0,  262,  261,    0,  262,    0,  250,    0,  264,
  264,  264,  264,  264,  264,    0,    0,  261,  261,  262,
  262,    0,  261,    0,  262,    0,    0,    0,  263,    0,
  365,  263,  368,  359,  263,  258,    0,  366,  363,    0,
  364,    0,  367,    0,    0,    0,  247,    0,  263,  263,
    0,    0,  365,  263,  368,  360,  361,  362,    0,  366,
  363,    0,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  264,    0,  360,  361,  362,
    0,    0,    0,  261,    0,  262,    0,    0,    0,  369,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,
    0,  369,    0,    0,  263,    2,    3,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
   97,   98,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  244,    0,    0,    0,    0,    0,    0,    0,  341,  342,
  343,  344,  345,  346,    0,    0,    0,    0,    0,    0,
  347,  348,    0,  349,  350,  351,  352,  545,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  244,    0,    0,    0,    0,
    0,    0,    0,  341,  342,  343,  344,  345,  346,    0,
    0,    0,    0,    0,    0,  347,  348,    0,  349,  350,
  351,  352,  365,    0,  368,  359,    0,    0,  917,  366,
  363,  918,  364,  136,  367,  136,  136,    0,    0,  276,
  136,  136,  136,  136,    0,  136,  356,  360,  361,  362,
  357,    0,    0,    0,    0,    0,    0,  136,  136,  136,
  136,  136,  365,    0,  368,  359,    0,    0,  546,  366,
  363,    0,  364,    0,  367,    0,    0,    0,    0,    0,
    0,  369,    0,    0,    0,    0,  356,  360,  361,  362,
  357,  365,  136,  368,  359,    0,    0,    0,  366,  363,
    0,  364,    0,  367,    0,    0,    0,    0,    0,    0,
    0,  358,    0,    0,  700,  356,  360,  361,  362,  357,
    0,  369,  136,    0,    0,    0,    0,    0,  365,    0,
  368,  359,    0,    0,    0,  366,  363,  743,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  369,  358,  356,  360,  361,  362,  357,  365,    0,  368,
  359,    0,    0,  758,  366,  363,    0,  364,    0,  367,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  358,  356,  360,  361,  362,  357,  365,  369,  368,  359,
    0,    0,  759,  366,  363,    0,  364,  365,  367,  368,
  359,    0,    0,  760,  366,  363,    0,  364,    0,  367,
  356,  360,  361,  362,  357,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,    0,  368,  359,
    0,    0,  761,  366,  363,    0,  364,    0,  367,    0,
    0,    0,    0,    0,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,  369,  368,  359,    0,
    0,  762,  366,  363,    0,  364,  365,  367,  368,  359,
    0,    0,  763,  366,  363,  358,  364,    0,  367,  356,
  360,  361,  362,  357,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,    0,  368,  359,    0,
    0,    0,  366,  363,  764,  364,    0,  367,    0,    0,
    0,    0,    0,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,  369,  368,  359,    0,    0,
  765,  366,  363,    0,  364,  365,  367,  368,  359,    0,
    0,  766,  366,  363,  358,  364,    0,  367,  356,  360,
  361,  362,  357,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,    0,  368,  359,    0,    0,
  767,  366,  363,    0,  364,    0,  367,    0,    0,    0,
    0,    0,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,  369,  368,  359,    0,    0,  768,
  366,  363,    0,  364,  365,  367,  368,  359,    0,    0,
  769,  366,  363,  358,  364,    0,  367,  356,  360,  361,
  362,  357,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,    0,  368,  359,    0,    0,    0,
  366,  363,  770,  364,    0,  367,    0,    0,    0,    0,
    0,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,  369,  368,  359,    0,    0,  771,  366,
  363,    0,  364,  365,  367,  368,  359,    0,    0,  772,
  366,  363,  358,  364,    0,  367,  356,  360,  361,  362,
  357,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,    0,  368,  359,    0,    0,    0,  366,
  363,  773,  364,    0,  367,    0,    0,    0,    0,    0,
    0,  369,  358,    0,    0,    0,  356,  360,  361,  362,
  357,  365,  369,  368,  359,    0,    0,  774,  366,  363,
    0,  364,  365,  367,  368,  359,    0,    0,  775,  366,
  363,  358,  364,    0,  367,  356,  360,  361,  362,  357,
    0,  369,  358,    0,    0,    0,  356,  360,  361,  362,
  357,  365,    0,  368,  359,    0,    0,  776,  366,  363,
    0,  364,    0,  367,    0,    0,    0,    0,    0,    0,
  369,  358,    0,    0,    0,  356,  360,  361,  362,  357,
  365,  369,  368,  359,    0,    0,  777,  366,  363,    0,
  364,  365,  367,  368,  359,    0,    0,  778,  366,  363,
  358,  364,    0,  367,  356,  360,  361,  362,  357,    0,
  369,  358,    0,    0,    0,  356,  360,  361,  362,  357,
  365,    0,  368,  359,    0,    0,    0,  366,  363,  781,
  364,    0,  367,    0,    0,    0,    0,    0,    0,  369,
  358,    0,    0,    0,  356,  360,  361,  362,  357,  365,
  369,  368,  359,    0,    0,    0,  366,  363,  784,  364,
  365,  367,  368,  359,    0,    0,  785,  366,  363,  358,
  364,    0,  367,  356,  360,  361,  362,  357,    0,  369,
  358,    0,    0,    0,  356,  360,  361,  362,  357,  365,
    0,  368,  359,    0,    0,    0,  366,  363,  786,  364,
    0,  367,    0,    0,    0,    0,    0,    0,  369,  358,
    0,    0,    0,  356,  360,  361,  362,  357,  365,  369,
  368,  359,    0,    0,    0,  366,  363,  787,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,  358,    0,
    0,    0,  356,  360,  361,  362,  357,    0,  369,  358,
    0,    0,    0,    0,    0,  365,    0,  368,  359,    0,
    0,    0,  366,  363,  788,  364,    0,  367,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  369,  358,  356,
  360,  361,  362,  357,  365,    0,  368,  359,    0,    0,
    0,  366,  363,  789,  364,    0,  367,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  358,  356,  360,
  361,  362,  357,  365,  369,  368,  359,    0,    0,    0,
  366,  363,  790,  364,  365,  367,  368,  359,    0,    0,
  791,  366,  363,    0,  364,    0,  367,  356,  360,  361,
  362,  357,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,    0,  368,  359,    0,    0,  792,
  366,  363,    0,  364,    0,  367,    0,    0,    0,    0,
    0,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,  369,  368,  359,    0,    0,  793,  366,
  363,    0,  364,  365,  367,  368,  359,    0,    0,  794,
  366,  363,  358,  364,    0,  367,  356,  360,  361,  362,
  357,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,    0,  368,  359,    0,    0,  795,  366,
  363,    0,  364,    0,  367,    0,    0,    0,    0,    0,
    0,  369,  358,    0,    0,    0,  356,  360,  361,  362,
  357,  365,  369,  368,  359,    0,    0,  796,  366,  363,
    0,  364,    0,  367,    0,    0,    0,    0,    0,    0,
    0,  358,    0,    0,    0,  356,  360,  361,  362,  357,
    0,  369,  358,    0,    0,    0,    0,    0,  365,    0,
  368,  359,    0,    0,    0,  366,  363,  799,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  369,  358,  356,  360,  361,  362,  357,  365,    0,  368,
  359,    0,    0,    0,  366,  363,  800,  364,    0,  367,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  358,  356,  360,  361,  362,  357,  365,  369,  368,  359,
    0,    0,    0,  366,  363,  801,  364,  365,  367,  368,
  359,    0,    0,    0,  366,  363,  802,  364,    0,  367,
  356,  360,  361,  362,  357,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,    0,  368,  359,
    0,    0,    0,  366,  363,  803,  364,    0,  367,    0,
    0,    0,    0,    0,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,  369,  368,  359,    0,
    0,  804,  366,  363,    0,  364,  365,  367,  368,  359,
    0,    0,  805,  366,  363,  358,  364,    0,  367,  356,
  360,  361,  362,  357,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,    0,  368,  359,    0,
    0,  806,  366,  363,    0,  364,    0,  367,    0,    0,
    0,    0,    0,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,  369,  368,  359,    0,    0,
  807,  366,  363,    0,  364,  365,  367,  368,  359,    0,
    0,  808,  366,  363,  358,  364,    0,  367,  356,  360,
  361,  362,  357,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,    0,  368,  359,    0,    0,
    0,  366,  363,  809,  364,    0,  367,    0,    0,    0,
    0,    0,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,  369,  368,  359,    0,    0,    0,
  366,  363,  810,  364,  365,  367,  368,  359,    0,    0,
  811,  366,  363,  358,  364,    0,  367,  356,  360,  361,
  362,  357,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,    0,  368,  359,    0,    0,  812,
  366,  363,    0,  364,    0,  367,    0,    0,    0,    0,
    0,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,  369,  368,  359,    0,    0,    0,  366,
  363,  813,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,  358,    0,    0,    0,  356,  360,  361,  362,
  357,    0,  369,  358,    0,    0,    0,    0,    0,  365,
    0,  368,  359,    0,    0,    0,  366,  363,  814,  364,
    0,  367,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  369,  358,  356,  360,  361,  362,  357,  365,    0,
  368,  359,    0,    0,    0,  366,  363,  815,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  358,  356,  360,  361,  362,  357,  365,  369,  368,
  359,    0,    0,    0,  366,  363,  817,  364,  365,  367,
  368,  359,    0,    0,    0,  366,  363,  819,  364,    0,
  367,  356,  360,  361,  362,  357,    0,  369,  358,    0,
    0,    0,  356,  360,  361,  362,  357,  365,    0,  368,
  359,    0,    0,    0,  366,  363,  821,  364,    0,  367,
    0,    0,    0,    0,    0,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,  369,  368,  359,
    0,    0,    0,  366,  363,  823,  364,    0,  367,    0,
    0,    0,    0,    0,    0,    0,  358,    0,    0,    0,
  356,  360,  361,  362,  357,    0,  369,  358,    0,    0,
    0,    0,    0,  365,    0,  368,  359,    0,    0,    0,
  366,  363,  825,  364,    0,  367,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  369,  358,  356,  360,  361,
  362,  357,  365,    0,  368,  359,    0,    0,  826,  366,
  363,    0,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  358,  356,  360,  361,  362,
  357,  365,  369,  368,  359,    0,    0,  827,  366,  363,
    0,  364,  365,  367,  368,  359,    0,    0,  828,  366,
  363,    0,  364,    0,  367,  356,  360,  361,  362,  357,
    0,  369,  358,    0,    0,    0,  356,  360,  361,  362,
  357,  365,    0,  368,  359,    0,    0,  829,  366,  363,
    0,  364,    0,  367,    0,    0,    0,    0,    0,    0,
  369,  358,    0,    0,    0,  356,  360,  361,  362,  357,
  365,  369,  368,  359,    0,    0,  830,  366,  363,    0,
  364,  365,  367,  368,  359,    0,    0,  831,  366,  363,
  358,  364,    0,  367,  356,  360,  361,  362,  357,    0,
  369,  358,    0,    0,    0,  356,  360,  361,  362,  357,
  365,    0,  368,  359,    0,    0,  878,  366,  363,    0,
  364,    0,  367,    0,    0,    0,    0,    0,    0,  369,
  358,    0,    0,    0,  356,  360,  361,  362,  357,  365,
  369,  368,  359,    0,    0,  879,  366,  363,    0,  364,
  365,  367,  368,  359,    0,    0,  880,  366,  363,  358,
  364,    0,  367,  356,  360,  361,  362,  357,    0,  369,
  358,    0,    0,    0,  356,  360,  361,  362,  357,  365,
    0,  368,  359,    0,    0,  881,  366,  363,    0,  364,
    0,  367,    0,    0,    0,    0,    0,    0,  369,  358,
    0,    0,    0,  356,  360,  361,  362,  357,  365,  369,
  368,  359,    0,    0,  882,  366,  363,    0,  364,  365,
  367,  368,  359,    0,    0,  883,  366,  363,  358,  364,
    0,  367,  356,  360,  361,  362,  357,    0,  369,  358,
    0,    0,    0,  356,  360,  361,  362,  357,  365,    0,
  368,  359,    0,    0,  884,  366,  363,    0,  364,    0,
  367,    0,    0,    0,    0,    0,    0,  369,  358,    0,
    0,    0,  356,  360,  361,  362,  357,  365,  369,  368,
  359,    0,    0,  885,  366,  363,    0,  364,  365,  367,
  368,  359,    0,    0,  886,  366,  363,  358,  364,    0,
  367,  356,  360,  361,  362,  357,    0,  369,  358,    0,
    0,    0,  356,  360,  361,  362,  357,  365,    0,  368,
  359,    0,    0,  887,  366,  363,    0,  364,    0,  367,
    0,    0,    0,    0,    0,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,  369,  368,  359,
    0,    0,  890,  366,  363,    0,  364,  365,  367,  368,
  359,    0,    0,  892,  366,  363,  358,  364,    0,  367,
  356,  360,  361,  362,  357,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,    0,  368,  359,
    0,    0,    0,  366,  363,  893,  364,    0,  367,    0,
    0,    0,    0,    0,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,  369,  368,  359,    0,
    0,    0,  366,  363,  894,  364,    0,  367,    0,    0,
    0,    0,    0,    0,    0,  358,    0,    0,    0,  356,
  360,  361,  362,  357,    0,  369,  358,    0,    0,    0,
    0,    0,  365,    0,  368,  359,    0,    0,    0,  366,
  363,  895,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  369,  358,  356,  360,  361,  362,
  357,  365,    0,  368,  359,    0,    0,    0,  366,  363,
  896,  364,    0,  367,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  358,  356,  360,  361,  362,  357,
  365,  369,  368,  359,    0,    0,  897,  366,  363,    0,
  364,  365,  367,  368,  359,    0,    0,    0,  366,  363,
  898,  364,    0,  367,  356,  360,  361,  362,  357,    0,
  369,  358,    0,    0,    0,  356,  360,  361,  362,  357,
  365,    0,  368,  359,    0,    0,    0,  366,  363,  899,
  364,    0,  367,    0,    0,    0,    0,    0,    0,  369,
  358,    0,    0,    0,  356,  360,  361,  362,  357,  365,
  369,  368,  359,    0,    0,  900,  366,  363,    0,  364,
    0,  367,    0,    0,    0,    0,    0,    0,    0,  358,
    0,    0,    0,  356,  360,  361,  362,  357,    0,  369,
  358,    0,    0,    0,    0,    0,  365,    0,  368,  359,
    0,    0,    0,  366,  363,  901,  364,    0,  367,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  369,  358,
  356,  360,  361,  362,  357,  365,    0,  368,  359,    0,
    0,    0,  366,  363,  902,  364,    0,  367,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  358,  356,
  360,  361,  362,  357,  365,  369,  368,  359,    0,    0,
  903,  366,  363,    0,  364,  365,  367,  368,  359,    0,
    0,  904,  366,  363,    0,  364,    0,  367,  356,  360,
  361,  362,  357,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,    0,  368,  359,    0,    0,
  905,  366,  363,    0,  364,    0,  367,    0,    0,    0,
    0,    0,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,  369,  368,  359,    0,    0,  906,
  366,  363,    0,  364,  365,  367,  368,  359,    0,    0,
  907,  366,  363,  358,  364,    0,  367,  356,  360,  361,
  362,  357,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,    0,  368,  359,    0,    0,  908,
  366,  363,    0,  364,    0,  367,    0,    0,    0,    0,
    0,    0,  369,  358,    0,    0,    0,  356,  360,  361,
  362,  357,  365,  369,  368,  359,    0,    0,    0,  366,
  363,  910,  364,    0,  367,    0,    0,    0,    0,    0,
    0,    0,  358,    0,    0,    0,  356,  360,  361,  362,
  357,    0,  369,  358,    0,    0,    0,    0,    0,  365,
    0,  368,  359,    0,    0,    0,  366,  363,  912,  364,
    0,  367,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  369,  358,  356,  360,  361,  362,  357,  365,    0,
  368,  359,    0,    0,  935,  366,  363,    0,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  358,  356,  360,  361,  362,  357,  365,  369,  368,
  359,    0,    0,  936,  366,  363,    0,  364,  365,  367,
  368,  359,    0,    0,  937,  366,  363,    0,  364,    0,
  367,  356,  360,  361,  362,  357,    0,  369,  358,    0,
    0,    0,  356,  360,  361,  362,  357,  365,    0,  368,
  359,    0,    0,  938,  366,  363,    0,  364,    0,  367,
    0,    0,    0,    0,    0,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,  369,  368,  359,
    0,    0,  939,  366,  363,    0,  364,  365,  367,  368,
  359,    0,    0,  940,  366,  363,  358,  364,    0,  367,
  356,  360,  361,  362,  357,    0,  369,  358,    0,    0,
    0,  356,  360,  361,  362,  357,  365,    0,  368,  359,
    0,    0,  941,  366,  363,    0,  364,    0,  367,    0,
    0,    0,    0,    0,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,  369,  368,  359,    0,
    0,  942,  366,  363,    0,  364,  365,  367,  368,  359,
    0,    0,  943,  366,  363,  358,  364,    0,  367,  356,
  360,  361,  362,  357,    0,  369,  358,    0,    0,    0,
  356,  360,  361,  362,  357,  365,    0,  368,  359,    0,
    0,  944,  366,  363,    0,  364,    0,  367,    0,    0,
    0,    0,    0,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,  369,  368,  359,    0,    0,
  945,  366,  363,    0,  364,  365,  367,  368,  359,    0,
    0,  946,  366,  363,  358,  364,    0,  367,  356,  360,
  361,  362,  357,    0,  369,  358,    0,    0,    0,  356,
  360,  361,  362,  357,  365,    0,  368,  359,    0,    0,
  947,  366,  363,    0,  364,    0,  367,    0,    0,    0,
    0,    0,    0,  369,  358,    0,    0,    0,  356,  360,
  361,  362,  357,  365,  369,  368,  359,    0,    0,  948,
  366,  363,    0,  364,    0,  367,    0,    0,    0,    0,
    0,    0,    0,  358,    0,    0,    0,  356,  360,  361,
  362,  357,    0,  369,  358,    0,    0,    0,    0,    0,
  136,    0,  136,  136,    0,    0,    0,  136,  136,  136,
  136,    0,  136,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  369,  358,  136,  136,  136,  136,  136,  365,
    0,  368,  359,    0,    0,    0,  366,  363,    0,  364,
    0,  367,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  358,  356,  360,  361,  362,  357,  365,  136,
  368,  359,    0,    0,    0,  366,  363,    0,  364,    0,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  360,  361,  362,    0,    0,  369,  136,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  369,  358,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  358,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
  422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
  432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
  442,  443,  444,
};
static const YYINT yycheck[] = {                         38,
   39,  259,  167,  168,   89,   36,   36,  259,  173,   36,
  259,  263,    0,  258,   35,   36,   37,  258,  259,   36,
   29,   35,   43,   37,   45,   41,   36,   58,   44,   43,
  258,   45,   41,   43,  258,   45,   36,   64,   41,   33,
  258,   44,   36,   64,   41,  259,   40,   44,   36,   43,
  258,   45,  257,   41,   64,   43,  257,   45,  123,   43,
  259,   45,  123,    0,   64,   36,   41,   61,   62,   44,
   64,  258,  259,   61,   36,  258,   64,  257,   14,   15,
   16,  257,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   64,   30,  258,  259,   33,   34,   35,
   36,   37,   64,  257,   41,   41,   42,   44,  273,   45,
   46,  257,   36,   49,   50,   51,   15,   16,  258,  259,
  257,   58,   59,  123,  258,  259,   63,   26,   27,  123,
  169,   30,  126,  172,  143,  144,  257,   37,  257,    0,
   64,  257,   42,   42,   36,  257,  257,   47,   84,   85,
  257,   36,  257,   89,  257,   91,   92,  257,  257,   18,
   19,   20,   21,   22,   23,   24,   25,   36,  257,   28,
  179,  180,   64,  257,   33,   34,  112,   36,  114,   64,
   41,  257,   41,   44,  257,  257,   45,   46,  257,  257,
   49,   50,   51,   33,   94,   64,   36,   58,  257,  257,
   40,   58,  259,   43,  259,   45,  259,  259,  259,  259,
   58,   58,  148,   58,  253,  254,  255,  256,  154,   58,
   58,   61,   58,  159,   64,   84,   85,   58,  259,  259,
  257,  258,   91,   92,  261,  262,  257,  258,  259,  260,
  261,  262,  259,  257,   58,  259,  260,  258,  258,  259,
  260,  261,  262,  112,  488,  114,   58,  259,  258,  257,
  159,  261,  262,  257,  258,  259,  260,  258,  262,  257,
  258,  259,  260,  261,  262,  259,  260,  258,  257,  259,
   61,   61,   61,  123,   61,  257,  126,  258,  257,  148,
  261,  262,  257,  257,  257,  154,  258,   46,  257,  261,
  262,  237,  238,  257,   35,  257,   37,  257,  257,  257,
  246,   42,   43,  257,   45,  257,   47,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  257,  257,   33,  258,  257,   36,  257,  262,  257,
   40,  257,  257,   43,   33,   45,  257,   36,  257,  259,
  258,   40,  259,  257,   43,  258,   45,  259,  259,   40,
  258,  258,  371,   94,   64,  257,  258,  257,  259,  261,
  262,  259,  257,  258,  258,   64,  261,  262,  237,  238,
  545,  259,  257,  259,  125,  259,   40,   40,  257,  258,
   40,   40,   40,  262,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,  257,  258,  259,
  260,  460,  262,  123,   40,   40,  126,   40,   40,   40,
   40,   40,   40,   40,  123,   40,   40,  126,   40,   40,
   40,   40,  481,  482,  483,  484,  485,  486,  487,  488,
  489,  490,  491,  492,  493,  494,  495,  496,  497,  498,
  499,  500,  501,  502,  503,  504,  505,  506,  507,  508,
  509,  510,  511,  512,  513,  514,  515,  516,  517,  518,
  519,  520,  521,  522,  523,  524,  525,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  591,  592,   40,   40,
  595,   40,  551,  552,  508,  509,  555,   40,   40,  455,
   40,   35,   40,   37,   38,   40,  259,   41,   42,   43,
   44,   45,   40,   47,  699,   40,   40,   40,  474,  475,
  476,  477,  478,  479,  480,   59,   60,   61,   62,   63,
   40,   40,   40,   40,   40,   40,   40,  257,  258,  259,
  260,  261,  262,   40,   40,   40,  502,  503,  257,  258,
  259,  260,   40,  262,   40,  474,  475,  476,  477,  478,
   94,    0,   40,   40,   40,   40,  125,  125,    0,  598,
  599,  600,  125,  259,   61,  258,  455,   61,  534,  535,
  536,  537,  538,  502,  503,   46,  258,   61,   61,   61,
  124,   61,   61,   61,   61,  474,  475,  476,  477,  478,
  479,  480,    0,   35,   61,   61,   38,   61,   61,   41,
    0,   43,   44,   45,   61,  534,  535,  536,  537,  538,
   61,   61,  259,  502,  503,   61,   58,   59,   60,   61,
   62,   63,   61,   61,   61,  591,  592,   35,   61,  595,
   38,  700,   61,   41,   61,   43,   44,   45,  508,  509,
    0,   41,   61,   61,   44,  611,   61,   61,    0,   61,
   58,   59,   60,   61,   62,   63,   61,   61,   58,   59,
   61,  258,   61,   63,   61,  259,   33,   33,   94,   33,
  259,  259,  259,  259,  743,  259,  259,  746,  259,  748,
  259,  750,  124,  752,   33,  754,   38,   36,  259,   41,
   44,   40,   44,  259,   43,  764,   45,    0,   41,  259,
   44,  770,  259,  259,  773,  259,   58,   59,  259,   41,
  779,   63,  259,  782,   44,   64,  124,  786,  787,  788,
  789,  790,  259,  259,  124,   41,   44,  259,  259,  798,
  799,  800,  801,  802,  803,  259,  259,  259,  704,  705,
  809,  810,   41,    0,  813,  814,  815,  816,  259,  818,
  259,  820,   44,  822,   41,  824,  259,   33,  259,    0,
   36,   41,   41,   44,   40,   41,  259,   43,  259,  259,
   41,   44,  124,   33,  123,   41,   36,  126,  508,  509,
   40,   38,   44,   43,   41,   44,   44,   44,   64,  508,
  509,   44,   44,   41,   44,  257,  257,   38,    0,   44,
   41,   58,   59,   44,   64,   41,   63,   41,    0,    0,
    0,    0,    0,    0,    0,  704,  705,   58,   59,    0,
  889,    0,   63,    0,  893,  894,  895,  896,    0,  898,
  899,    0,  901,  902,    0,    0,    0,    0,    0,    0,
    0,  910,  911,  912,  913,    0,  915,  123,    0,  918,
  126,  817,    0,  819,    0,  821,    0,  823,    0,  825,
    0,   41,   -1,  123,   -1,  784,  126,  124,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   -1,   -1,    0,  817,   -1,
  819,   -1,  821,   -1,  823,   -1,  825,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,  262,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,  415,  416,  417,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,  262,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,    0,   -1,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
  413,  414,  415,  416,  417,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  508,
  509,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  414,  415,  416,  417,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  508,  509,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  508,  509,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
  413,  414,  415,  416,  417,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  414,  415,  416,  417,    0,   -1,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
  414,  415,  416,  417,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
  413,  414,  415,  416,  417,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
  414,  415,  416,  417,    0,   -1,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,  375,  376,
  377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
  387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
  416,  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,  375,  376,
  377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
  387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
  416,  417,    0,   -1,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,  415,  416,  417,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
  378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
  398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
  408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,  415,  416,  417,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,  375,  376,
  377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
  387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
  417,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
  378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
  398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
  408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
    0,   -1,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,  415,  416,  417,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,   -1,   -1,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
  413,  414,  415,  416,  417,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,  414,  415,  416,  417,    0,   -1,   -1,   -1,
   -1,   -1,   35,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   59,   60,   61,   62,
   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   35,   94,   37,   38,    0,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,   -1,
   94,  124,   -1,    0,   -1,   -1,   -1,   -1,   -1,   35,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,    0,   58,   59,   60,   61,   62,   63,   35,   -1,
   37,   38,    0,   -1,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,   38,
   -1,    0,   41,   -1,   -1,   44,   -1,   35,   -1,    0,
   38,    0,   -1,   41,   -1,   43,   44,   45,   -1,   58,
   59,   -1,   -1,   -1,   63,   -1,   -1,   -1,  124,   -1,
   58,   59,   60,   61,   62,   63,   35,   -1,   -1,   38,
    0,   -1,   41,   -1,   43,   44,   45,   38,   -1,   38,
   41,   -1,   41,   44,   -1,   44,   -1,  124,   -1,   58,
   59,   60,   61,   62,   63,   -1,   -1,   58,   59,   58,
   59,   -1,   63,   -1,   63,   -1,   -1,   -1,   38,   -1,
   35,   41,   37,   38,   44,  124,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,  124,   -1,   58,   59,
   -1,   -1,   35,   63,   37,   60,   61,   62,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   60,   61,   62,
   -1,   -1,   -1,  124,   -1,  124,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,  124,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  420,  421,  422,  423,  424,  425,  426,  427,
  428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
  438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
  458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
  488,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  496,  497,
  498,  499,  500,  501,   -1,   -1,   -1,   -1,   -1,   -1,
  508,  509,   -1,  511,  512,  513,  514,  420,  421,  422,
  423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
  433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
  443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
  453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
  463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
  483,  484,  485,  486,  487,  488,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  496,  497,  498,  499,  500,  501,   -1,
   -1,   -1,   -1,   -1,   -1,  508,  509,   -1,  511,  512,
  513,  514,   35,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   44,   45,   35,   47,   37,   38,   -1,   -1,   41,
   42,   43,   44,   45,   -1,   47,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   35,   94,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   94,  124,   -1,   -1,   -1,   -1,   -1,   35,   -1,
   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,  124,   59,   60,   61,   62,   63,   35,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   59,   60,   61,   62,   63,   35,   94,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   35,   47,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   59,   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   -1,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   94,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   35,   47,   37,   38,
   -1,   -1,   41,   42,   43,  124,   45,   -1,   47,   59,
   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   94,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   35,   47,   37,   38,   -1,
   -1,   41,   42,   43,  124,   45,   -1,   47,   59,   60,
   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   94,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   35,   47,   37,   38,   -1,   -1,
   41,   42,   43,  124,   45,   -1,   47,   59,   60,   61,
   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   94,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   35,   47,   37,   38,   -1,   -1,   41,
   42,   43,  124,   45,   -1,   47,   59,   60,   61,   62,
   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   35,   94,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   35,   47,   37,   38,   -1,   -1,   41,   42,
   43,  124,   45,   -1,   47,   59,   60,   61,   62,   63,
   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   35,   94,   37,   38,   -1,   -1,   41,   42,   43,   -1,
   45,   35,   47,   37,   38,   -1,   -1,   41,   42,   43,
  124,   45,   -1,   47,   59,   60,   61,   62,   63,   -1,
   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   35,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,
  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,
   94,   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,
   35,   47,   37,   38,   -1,   -1,   41,   42,   43,  124,
   45,   -1,   47,   59,   60,   61,   62,   63,   -1,   94,
  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,   94,
   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,
   -1,   -1,   59,   60,   61,   62,   63,   -1,   94,  124,
   -1,   -1,   -1,   -1,   -1,   35,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   59,
   60,   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   59,   60,
   61,   62,   63,   35,   94,   37,   38,   -1,   -1,   -1,
   42,   43,   44,   45,   35,   47,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   59,   60,   61,
   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   94,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   35,   47,   37,   38,   -1,   -1,   41,
   42,   43,  124,   45,   -1,   47,   59,   60,   61,   62,
   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   35,   94,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   -1,   94,  124,   -1,   -1,   -1,   -1,   -1,   35,   -1,
   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,  124,   59,   60,   61,   62,   63,   35,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,   59,   60,   61,   62,   63,   35,   94,   37,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   35,   47,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   59,   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   94,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   35,   47,   37,   38,
   -1,   -1,   41,   42,   43,  124,   45,   -1,   47,   59,
   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   94,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   35,   47,   37,   38,   -1,
   -1,   41,   42,   43,  124,   45,   -1,   47,   59,   60,
   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   94,   37,   38,   -1,   -1,   -1,
   42,   43,   44,   45,   35,   47,   37,   38,   -1,   -1,
   41,   42,   43,  124,   45,   -1,   47,   59,   60,   61,
   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   94,   37,   38,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   -1,   94,  124,   -1,   -1,   -1,   -1,   -1,   35,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  124,   59,   60,   61,   62,   63,   35,   -1,
   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   59,   60,   61,   62,   63,   35,   94,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   35,   47,
   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   59,   60,   61,   62,   63,   -1,   94,  124,   -1,
   -1,   -1,   59,   60,   61,   62,   63,   35,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   94,   37,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,
   -1,   -1,   -1,   35,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  124,   59,   60,   61,
   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   59,   60,   61,   62,
   63,   35,   94,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   35,   47,   37,   38,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   59,   60,   61,   62,   63,
   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   35,   -1,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   35,   94,   37,   38,   -1,   -1,   41,   42,   43,   -1,
   45,   35,   47,   37,   38,   -1,   -1,   41,   42,   43,
  124,   45,   -1,   47,   59,   60,   61,   62,   63,   -1,
   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   35,   -1,   37,   38,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,
  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,
   94,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   35,   47,   37,   38,   -1,   -1,   41,   42,   43,  124,
   45,   -1,   47,   59,   60,   61,   62,   63,   -1,   94,
  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,   94,
   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,   35,
   47,   37,   38,   -1,   -1,   41,   42,   43,  124,   45,
   -1,   47,   59,   60,   61,   62,   63,   -1,   94,  124,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,   -1,
   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,
   -1,   -1,   59,   60,   61,   62,   63,   35,   94,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   35,   47,
   37,   38,   -1,   -1,   41,   42,   43,  124,   45,   -1,
   47,   59,   60,   61,   62,   63,   -1,   94,  124,   -1,
   -1,   -1,   59,   60,   61,   62,   63,   35,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   94,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   35,   47,   37,
   38,   -1,   -1,   41,   42,   43,  124,   45,   -1,   47,
   59,   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   94,   37,   38,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,
   -1,   -1,   35,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,  124,   59,   60,   61,   62,
   63,   35,   -1,   37,   38,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   59,   60,   61,   62,   63,
   35,   94,   37,   38,   -1,   -1,   41,   42,   43,   -1,
   45,   35,   47,   37,   38,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   59,   60,   61,   62,   63,   -1,
   94,  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   35,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,
  124,   -1,   -1,   -1,   59,   60,   61,   62,   63,   35,
   94,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   -1,   94,
  124,   -1,   -1,   -1,   -1,   -1,   35,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,
   59,   60,   61,   62,   63,   35,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   59,
   60,   61,   62,   63,   35,   94,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   35,   47,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   59,   60,
   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   94,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   35,   47,   37,   38,   -1,   -1,
   41,   42,   43,  124,   45,   -1,   47,   59,   60,   61,
   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   35,   94,   37,   38,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   -1,   94,  124,   -1,   -1,   -1,   -1,   -1,   35,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  124,   59,   60,   61,   62,   63,   35,   -1,
   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   59,   60,   61,   62,   63,   35,   94,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   35,   47,
   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   59,   60,   61,   62,   63,   -1,   94,  124,   -1,
   -1,   -1,   59,   60,   61,   62,   63,   35,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   94,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   35,   47,   37,
   38,   -1,   -1,   41,   42,   43,  124,   45,   -1,   47,
   59,   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,
   -1,   59,   60,   61,   62,   63,   35,   -1,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   94,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   35,   47,   37,   38,
   -1,   -1,   41,   42,   43,  124,   45,   -1,   47,   59,
   60,   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,
   59,   60,   61,   62,   63,   35,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   94,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   35,   47,   37,   38,   -1,
   -1,   41,   42,   43,  124,   45,   -1,   47,   59,   60,
   61,   62,   63,   -1,   94,  124,   -1,   -1,   -1,   59,
   60,   61,   62,   63,   35,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   94,  124,   -1,   -1,   -1,   59,   60,
   61,   62,   63,   35,   94,   37,   38,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   -1,   94,  124,   -1,   -1,   -1,   -1,   -1,
   35,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  124,   59,   60,   61,   62,   63,   35,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   59,   60,   61,   62,   63,   35,   94,
   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   94,  124,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  124,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,
};
#endif
#define YYFINAL 99
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 514
#define YYUNDFTOKEN 527
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'!'",0,
"'#'","'$'","'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'","'?'","'@'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","STRING",
"COL","NUMBER","FNUMBER","RANGE","VAR","WORD","MAPWORD","PLUGIN","S_SHOW",
"S_HIDE","S_SHOWROW","S_HIDEROW","S_SHOWCOL","S_HIDECOL","S_FREEZE",
"S_UNFREEZE","S_MARK","S_AUTOFIT","S_PAD","S_DELETECOL","S_DATEFMT",
"S_SUBTOTAL","S_RSUBTOTAL","S_FORMAT","S_FMT","S_LET","S_LABEL","S_LEFTSTRING",
"S_RIGHTSTRING","S_LEFTJUSTIFY","S_RIGHTJUSTIFY","S_CENTER","S_SORT",
"S_FILTERON","S_GOTO","S_GOTOB","S_CCOPY","S_CPASTE","S_PLOT","S_LOCK",
"S_UNLOCK","S_DEFINE","S_UNDEFINE","S_DETAIL","S_EVAL","S_SEVAL","S_ERROR",
"S_FILL","S_STRTONUM","S_DELETEROW","S_VALUEIZEALL","S_SHIFT","S_GETNUM",
"S_YANKAREA","S_PASTEYANKED","S_GETSTRING","S_GETEXP","S_GETFMT","S_GETFORMAT",
"S_RECALC","S_EXECUTE","S_QUIT","S_EXPORT","S_REBUILD_GRAPH","S_PRINT_GRAPH",
"S_SYNCREFS","S_REDO","S_UNDO","S_IMAP","S_EMAP","S_CMAP","S_NEWSHEET",
"S_NEXTSHEET","S_PREVSHEET","S_DELSHEET","S_MOVETOSHEET","S_RENAMESHEET",
"S_NMAP","S_VMAP","S_INOREMAP","S_ENOREMAP","S_CNOREMAP","S_NNOREMAP",
"S_VNOREMAP","S_NUNMAP","S_IUNMAP","S_EUNMAP","S_CUNMAP","S_VUNMAP","S_COLOR",
"S_CELLCOLOR","S_UNFORMAT","S_REDEFINE_COLOR","S_DEFINE_COLOR","S_SET",
"S_FCOPY","S_FSUM","S_TRIGGER","S_UNTRIGGER","S_OFFSCR_SC_COLS",
"S_OFFSCR_SC_ROWS","S_NB_FROZEN_ROWS","S_NB_FROZEN_COLS",
"S_NB_FROZEN_SCREENROWS","S_NB_FROZEN_SCREENCOLS","K_AUTOBACKUP",
"K_NOAUTOBACKUP","K_AUTOCALC","K_NOAUTOCALC","K_DEBUG","K_NODEBUG","K_TRG",
"K_NOTRG","K_EXTERNAL_FUNCTIONS","K_NOEXTERNAL_FUNCTIONS","K_EXEC_LUA",
"K_NOEXEC_LUA","K_HALF_PAGE_SCROLL","K_NOHALF_PAGE_SCROLL","K_NOCURSES",
"K_CURSES","K_NUMERIC","K_NONUMERIC","K_NUMERIC_DECIMAL","K_NONUMERIC_DECIMAL",
"K_NUMERIC_ZERO","K_NONUMERIC_ZERO","K_OVERLAP","K_NOOVERLAP",
"K_INPUT_BAR_BOTTOM","K_IGNORE_HIDDEN","K_NOIGNORE_HIDDEN","K_INPUT_EDIT_MODE",
"K_UNDERLINE_GRID","K_TRUNCATE","K_NOTRUNCATE","K_AUTOWRAP","K_NOAUTOWRAP",
"K_QUIET","K_NOQUIET","K_QUIT_AFTERLOAD","K_NOQUIT_AFTERLOAD",
"K_XLSX_READFORMULAS","K_NOXLSX_READFORMULAS","K_DEFAULT_COPY_TO_CLIPBOARD_CMD",
"K_DEFAULT_PASTE_FROM_CLIPBOARD_CMD","K_COPY_TO_CLIPBOARD_DELIMITED_TAB",
"K_NOCOPY_TO_CLIPBOARD_DELIMITED_TAB","K_COPY_TO_CLIPBOARD_WYSIWYG",
"K_NOCOPY_TO_CLIPBOARD_WYSIWYG","K_DEFAULT_OPEN_FILE_UNDER_CURSOR_CMD",
"K_IMPORT_DELIMITED_TO_TEXT","K_IGNORECASE","K_NOIGNORECASE","K_TM_GMTOFF",
"K_COMMAND_TIMEOUT","K_MAPPING_TIMEOUT","K_NEWLINE_ACTION","K_SHOW_CURSOR",
"K_NOSHOW_CURSOR","K_ERROR","K_INVALID","K_FIXED","K_SUM","K_PROD","K_AVG",
"K_STDDEV","K_COUNT","K_ROWS","K_COLS","K_ABS","K_FROW","K_FCOL","K_ACOS",
"K_ASIN","K_ATAN","K_ATAN2","K_CEIL","K_COS","K_EXP","K_FABS","K_FLOOR",
"K_HYPOT","K_LN","K_LOG","K_PI","K_POW","K_SIN","K_SQRT","K_TAN","K_DTR",
"K_RTD","K_MAX","K_MIN","K_RND","K_ROUND","K_IF","K_PV","K_FV","K_PMT","K_HOUR",
"K_MINUTE","K_SECOND","K_MONTH","K_DAY","K_YEAR","K_NOW","K_DATE","K_DTS",
"K_TTS","K_FMT","K_REPLACE","K_SUBSTR","K_UPPER","K_LOWER","K_CAPITAL","K_STON",
"K_SLEN","K_EQS","K_EXT","K_EVALUATE","K_SEVALUATE","K_LUA","K_NVAL","K_SVAL",
"K_LOOKUP","K_HLOOKUP","K_VLOOKUP","K_INDEX","K_STINDEX","K_GETENT",
"K_TBLSTYLE","K_TBL","K_LATEX","K_SLATEX","K_TEX","K_FRAME","K_RNDTOEVEN",
"K_FILENAME","K_MYROW","K_MYCOL","K_LASTROW","K_LASTCOL","K_COLTOA",
"K_CRACTION","K_CRROW","K_CRCOL","K_ROWLIMIT","K_COLLIMIT","K_PAGESIZE","K_ERR",
"K_REF","K_LOCALE","K_SET8BIT","K_ASCII","K_CHR","K_FACT","$accept","command",
"var","num","range","var_or_range","strarg","e","term","expr_list","setlist",
"setitem","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : command",
"command : S_LET var_or_range '=' e",
"command : S_LET var_or_range '='",
"command : S_LABEL var_or_range '=' e",
"command : S_LEFTSTRING var_or_range '=' e",
"command : S_RIGHTSTRING var_or_range '=' e",
"command : S_LEFTJUSTIFY var_or_range",
"command : S_RIGHTJUSTIFY var_or_range",
"command : S_CENTER var_or_range",
"command : S_FMT var_or_range STRING",
"command : S_DATEFMT var_or_range STRING",
"command : S_DATEFMT STRING",
"command : S_HIDE COL",
"command : S_HIDE NUMBER",
"command : S_SHOW COL",
"command : S_SHOW NUMBER",
"command : S_DELETECOL COL",
"command : S_DELETEROW NUMBER",
"command : S_HIDECOL COL",
"command : S_SHOWCOL COL",
"command : S_HIDEROW NUMBER",
"command : S_SHOWROW NUMBER",
"command : S_SHOWCOL COL ':' COL",
"command : S_SHOWROW NUMBER ':' NUMBER",
"command : S_HIDECOL COL ':' COL",
"command : S_HIDEROW NUMBER ':' NUMBER",
"command : S_VALUEIZEALL",
"command : S_SHIFT var_or_range STRING",
"command : S_MARK COL var_or_range",
"command : S_MARK COL var_or_range var_or_range",
"command : S_MARK COL STRING var_or_range",
"command : S_MARK COL STRING var_or_range var_or_range",
"command : S_FILL var_or_range num num",
"command : S_FILL num num",
"command : S_FREEZE NUMBER ':' NUMBER",
"command : S_FREEZE NUMBER",
"command : S_FREEZE COL ':' COL",
"command : S_FREEZE COL",
"command : S_UNFREEZE NUMBER ':' NUMBER",
"command : S_UNFREEZE NUMBER",
"command : S_UNFREEZE COL ':' COL",
"command : S_UNFREEZE COL",
"command : S_SORT range STRING",
"command : S_SUBTOTAL range COL STRING COL",
"command : S_RSUBTOTAL range COL STRING COL",
"command : S_AUTOFIT COL ':' COL",
"command : S_AUTOFIT COL",
"command : S_PAD NUMBER COL ':' COL",
"command : S_PAD NUMBER COL",
"command : S_PAD NUMBER var_or_range",
"command : S_GETFORMAT COL",
"command : S_FORMAT COL NUMBER NUMBER NUMBER",
"command : S_FORMAT NUMBER NUMBER",
"command : S_FILTERON range",
"command : S_GOTO var_or_range var_or_range",
"command : S_GOTO var_or_range",
"command : S_GOTO num",
"command : S_GOTO STRING",
"command : S_GOTO '#' STRING",
"command : S_GOTO '%' STRING",
"command : S_GOTOB num",
"command : S_GOTOB STRING",
"command : S_GOTOB '#' STRING",
"command : S_GOTOB '%' STRING",
"command : S_CCOPY range",
"command : S_STRTONUM range",
"command : S_CPASTE",
"command : S_LOCK var_or_range",
"command : S_UNLOCK var_or_range",
"command : S_NEWSHEET STRING",
"command : S_DELSHEET STRING",
"command : S_DELSHEET",
"command : S_NEXTSHEET",
"command : S_PREVSHEET",
"command : S_MOVETOSHEET STRING",
"command : S_RENAMESHEET STRING",
"command : S_NMAP STRING STRING",
"command : S_IMAP STRING STRING",
"command : S_EMAP STRING STRING",
"command : S_VMAP STRING STRING",
"command : S_CMAP STRING STRING",
"command : S_NNOREMAP STRING STRING",
"command : S_INOREMAP STRING STRING",
"command : S_ENOREMAP STRING STRING",
"command : S_VNOREMAP STRING STRING",
"command : S_CNOREMAP STRING STRING",
"command : S_NUNMAP STRING",
"command : S_IUNMAP STRING",
"command : S_EUNMAP STRING",
"command : S_VUNMAP STRING",
"command : S_CUNMAP STRING",
"command : S_COLOR STRING",
"command : S_DETAIL var",
"command : S_CELLCOLOR var_or_range STRING",
"command : S_TRIGGER var_or_range STRING",
"command : S_OFFSCR_SC_COLS NUMBER",
"command : S_OFFSCR_SC_ROWS NUMBER",
"command : S_NB_FROZEN_ROWS NUMBER",
"command : S_NB_FROZEN_COLS NUMBER",
"command : S_NB_FROZEN_SCREENROWS NUMBER",
"command : S_NB_FROZEN_SCREENCOLS NUMBER",
"command : S_UNTRIGGER var_or_range",
"command : S_CELLCOLOR STRING",
"command : S_UNFORMAT var_or_range",
"command : S_UNFORMAT",
"command : S_REDEFINE_COLOR STRING NUMBER NUMBER NUMBER",
"command : S_DEFINE_COLOR STRING NUMBER NUMBER NUMBER",
"command : S_FCOPY",
"command : S_FCOPY strarg",
"command : S_FSUM",
"command : S_PLOT STRING var_or_range",
"command : S_SET setlist",
"command : S_DEFINE strarg range",
"command : S_DEFINE strarg var",
"command : S_UNDEFINE var_or_range",
"command : S_EVAL e",
"command : S_EXECUTE STRING",
"command : S_EXPORT STRING STRING",
"command : S_QUIT",
"command : S_REBUILD_GRAPH",
"command : S_PRINT_GRAPH",
"command : S_SYNCREFS",
"command : S_UNDO",
"command : S_REDO",
"command : S_RECALC",
"command : S_GETNUM var_or_range",
"command : S_GETNUM '{' STRING '}' '!' var_or_range",
"command : S_GETSTRING var_or_range",
"command : S_GETEXP var_or_range",
"command : S_GETFMT var_or_range",
"command : S_YANKAREA '{' STRING '}' '!' var_or_range STRING",
"command : S_PASTEYANKED '{' STRING '}' NUMBER STRING",
"command : S_SEVAL e",
"command : S_ERROR STRING",
"command :",
"command : error",
"term : var",
"term : '{' STRING '}' '!' var",
"term : '@' K_FIXED term",
"term : '(' '@' K_FIXED ')' term",
"term : '@' K_SUM '(' var_or_range ')'",
"term : '@' K_SUM '(' range ',' e ')'",
"term : '@' K_PROD '(' var_or_range ')'",
"term : '@' K_PROD '(' range ',' e ')'",
"term : '@' K_AVG '(' var_or_range ')'",
"term : '@' K_AVG '(' range ',' e ')'",
"term : '@' K_STDDEV '(' var_or_range ')'",
"term : '@' K_STDDEV '(' range ',' e ')'",
"term : '@' K_COUNT '(' var_or_range ')'",
"term : '@' K_COUNT '(' range ',' e ')'",
"term : '@' K_MAX '(' var_or_range ')'",
"term : '@' K_MAX '(' range ',' e ')'",
"term : '@' K_MAX '(' e ',' expr_list ')'",
"term : '@' K_MIN '(' var_or_range ')'",
"term : '@' K_MIN '(' range ',' e ')'",
"term : '@' K_MIN '(' e ',' expr_list ')'",
"term : '@' K_ROWS '(' var_or_range ')'",
"term : '@' K_COLS '(' var_or_range ')'",
"term : '@' K_ABS '(' e ')'",
"term : '@' K_FROW '(' e ')'",
"term : '@' K_FCOL '(' e ')'",
"term : '@' K_ACOS '(' e ')'",
"term : '@' K_ASIN '(' e ')'",
"term : '@' K_ATAN '(' e ')'",
"term : '@' K_ATAN2 '(' e ',' e ')'",
"term : '@' K_CEIL '(' e ')'",
"term : '@' K_COS '(' e ')'",
"term : '@' K_EXP '(' e ')'",
"term : '@' K_FABS '(' e ')'",
"term : '@' K_FLOOR '(' e ')'",
"term : '@' K_HYPOT '(' e ',' e ')'",
"term : '@' K_LN '(' e ')'",
"term : '@' K_LOG '(' e ')'",
"term : '@' K_POW '(' e ',' e ')'",
"term : '@' K_SIN '(' e ')'",
"term : '@' K_SQRT '(' e ')'",
"term : '@' K_TAN '(' e ')'",
"term : '@' K_DTR '(' e ')'",
"term : '@' K_RTD '(' e ')'",
"term : '@' K_RND '(' e ')'",
"term : '@' K_ROUND '(' e ',' e ')'",
"term : '@' K_IF '(' e ',' e ',' e ')'",
"term : '@' K_PV '(' e ',' e ',' e ')'",
"term : '@' K_FV '(' e ',' e ',' e ')'",
"term : '@' K_PMT '(' e ',' e ',' e ')'",
"term : '@' K_HOUR '(' e ')'",
"term : '@' K_MINUTE '(' e ')'",
"term : '@' K_SECOND '(' e ')'",
"term : '@' K_MONTH '(' e ')'",
"term : '@' K_DAY '(' e ')'",
"term : '@' K_YEAR '(' e ')'",
"term : '@' K_NOW",
"term : '@' K_DTS '(' e ',' e ',' e ')'",
"term : NUMBER '.' NUMBER '.' NUMBER",
"term : '@' K_TTS '(' e ',' e ',' e ')'",
"term : '@' K_STON '(' e ')'",
"term : '@' K_SLEN '(' e ')'",
"term : '@' K_EQS '(' e ',' e ')'",
"term : '@' K_DATE '(' e ')'",
"term : '@' K_DATE '(' e ',' e ')'",
"term : '@' K_FMT '(' e ',' e ')'",
"term : '@' K_UPPER '(' e ')'",
"term : '@' K_LOWER '(' e ')'",
"term : '@' K_CAPITAL '(' e ')'",
"term : '@' K_INDEX '(' range ',' e ')'",
"term : '@' K_INDEX '(' e ',' range ')'",
"term : '@' K_INDEX '(' range ',' e ',' e ')'",
"term : '@' K_LOOKUP '(' range ',' e ')'",
"term : '@' K_LOOKUP '(' e ',' range ')'",
"term : '@' K_HLOOKUP '(' range ',' e ',' e ')'",
"term : '@' K_HLOOKUP '(' e ',' range ',' e ')'",
"term : '@' K_VLOOKUP '(' range ',' e ',' e ')'",
"term : '@' K_VLOOKUP '(' e ',' range ',' e ')'",
"term : '@' K_STINDEX '(' range ',' e ')'",
"term : '@' K_STINDEX '(' e ',' range ')'",
"term : '@' K_STINDEX '(' range ',' e ',' e ')'",
"term : '@' K_EXT '(' e ',' e ')'",
"term : '@' K_LUA '(' e ',' e ')'",
"term : '@' K_MYROW",
"term : '@' K_MYCOL",
"term : '@' K_LASTROW",
"term : '@' K_LASTCOL",
"term : '@' K_NVAL '(' e ',' e ')'",
"term : '@' K_SVAL '(' e ',' e ')'",
"term : '@' K_REPLACE '(' e ',' e ',' e ')'",
"term : '@' K_EVALUATE '(' e ')'",
"term : '@' K_SEVALUATE '(' e ')'",
"term : '@' K_SUBSTR '(' e ',' e ',' e ')'",
"term : '(' e ')'",
"term : '+' term",
"term : NUMBER",
"term : FNUMBER",
"term : '@' K_PI",
"term : STRING",
"term : '~' term",
"term : '!' term",
"term : '@' K_FILENAME '(' e ')'",
"term : '@' K_COLTOA '(' e ')'",
"term : '@' K_ASCII '(' e ')'",
"term : '@' K_SET8BIT '(' e ')'",
"term : '@' K_CHR '(' e ')'",
"term : '@' K_ERR",
"term : K_ERR",
"term : '@' K_REF",
"term : K_REF",
"term : '@' K_FACT '(' e ')'",
"e : e '+' e",
"e : e '-' e",
"e : e '*' e",
"e : e '/' e",
"e : e '%' e",
"e : '-' e",
"e : e '^' e",
"e : term",
"e : e '?' e ':' e",
"e : e ';' e",
"e : e '<' e",
"e : e '=' e",
"e : e '>' e",
"e : e '&' e",
"e : e '|' e",
"e : e '<' '=' e",
"e : e '<' '>' e",
"e : e '>' '=' e",
"e : e '#' e",
"expr_list : e",
"expr_list : expr_list ',' e",
"range : var ':' var",
"range : RANGE",
"var : COL NUMBER",
"var : '$' COL NUMBER",
"var : COL '$' NUMBER",
"var : '$' COL '$' NUMBER",
"var : '@' K_GETENT '(' e ',' e ')'",
"var : VAR",
"var_or_range : range",
"var_or_range : var",
"num : NUMBER",
"num : FNUMBER",
"num : '-' num",
"num : '+' num",
"strarg : STRING",
"strarg : var",
"setlist :",
"setlist : setlist setitem",
"setitem : K_OVERLAP '=' NUMBER",
"setitem : K_OVERLAP",
"setitem : K_INPUT_BAR_BOTTOM '=' NUMBER",
"setitem : K_INPUT_BAR_BOTTOM",
"setitem : K_INPUT_EDIT_MODE '=' NUMBER",
"setitem : K_INPUT_EDIT_MODE",
"setitem : K_UNDERLINE_GRID '=' NUMBER",
"setitem : K_UNDERLINE_GRID",
"setitem : K_NOOVERLAP",
"setitem : K_TRUNCATE '=' NUMBER",
"setitem : K_TRUNCATE",
"setitem : K_NOTRUNCATE",
"setitem : K_AUTOWRAP '=' NUMBER",
"setitem : K_AUTOWRAP",
"setitem : K_NOAUTOWRAP",
"setitem : K_AUTOBACKUP '=' NUMBER",
"setitem : K_NOAUTOBACKUP",
"setitem : K_AUTOCALC",
"setitem : K_AUTOCALC '=' NUMBER",
"setitem : K_NOAUTOCALC",
"setitem : K_DEBUG",
"setitem : K_DEBUG '=' NUMBER",
"setitem : K_NODEBUG",
"setitem : K_TRG",
"setitem : K_TRG '=' NUMBER",
"setitem : K_NOTRG",
"setitem : K_EXTERNAL_FUNCTIONS",
"setitem : K_EXTERNAL_FUNCTIONS '=' NUMBER",
"setitem : K_NOEXTERNAL_FUNCTIONS",
"setitem : K_EXEC_LUA",
"setitem : K_EXEC_LUA '=' NUMBER",
"setitem : K_NOEXEC_LUA",
"setitem : K_HALF_PAGE_SCROLL",
"setitem : K_HALF_PAGE_SCROLL '=' NUMBER",
"setitem : K_NOHALF_PAGE_SCROLL",
"setitem : K_IGNORE_HIDDEN",
"setitem : K_IGNORE_HIDDEN '=' NUMBER",
"setitem : K_NOIGNORE_HIDDEN",
"setitem : K_QUIET '=' NUMBER",
"setitem : K_QUIET",
"setitem : K_NOQUIET",
"setitem : K_QUIT_AFTERLOAD",
"setitem : K_QUIT_AFTERLOAD '=' NUMBER",
"setitem : K_NOQUIT_AFTERLOAD",
"setitem : K_XLSX_READFORMULAS",
"setitem : K_XLSX_READFORMULAS '=' NUMBER",
"setitem : K_NOXLSX_READFORMULAS",
"setitem : K_NOCURSES",
"setitem : K_NOCURSES '=' NUMBER",
"setitem : K_CURSES",
"setitem : K_NUMERIC",
"setitem : K_NUMERIC '=' NUMBER",
"setitem : K_NONUMERIC",
"setitem : K_IGNORECASE",
"setitem : K_IGNORECASE '=' NUMBER",
"setitem : K_NOIGNORECASE",
"setitem : K_NUMERIC_DECIMAL",
"setitem : K_NUMERIC_DECIMAL '=' NUMBER",
"setitem : K_NONUMERIC_DECIMAL",
"setitem : K_NUMERIC_ZERO",
"setitem : K_NUMERIC_ZERO '=' NUMBER",
"setitem : K_NONUMERIC_ZERO",
"setitem : K_NEWLINE_ACTION",
"setitem : K_NEWLINE_ACTION '=' WORD",
"setitem : K_DEFAULT_COPY_TO_CLIPBOARD_CMD '=' strarg",
"setitem : K_DEFAULT_PASTE_FROM_CLIPBOARD_CMD '=' strarg",
"setitem : K_IMPORT_DELIMITED_TO_TEXT",
"setitem : K_IMPORT_DELIMITED_TO_TEXT '=' NUMBER",
"setitem : K_COPY_TO_CLIPBOARD_DELIMITED_TAB",
"setitem : K_COPY_TO_CLIPBOARD_DELIMITED_TAB '=' NUMBER",
"setitem : K_NOCOPY_TO_CLIPBOARD_DELIMITED_TAB",
"setitem : K_COPY_TO_CLIPBOARD_WYSIWYG",
"setitem : K_COPY_TO_CLIPBOARD_WYSIWYG '=' NUMBER",
"setitem : K_NOCOPY_TO_CLIPBOARD_WYSIWYG",
"setitem : K_DEFAULT_OPEN_FILE_UNDER_CURSOR_CMD '=' strarg",
"setitem : K_NEWLINE_ACTION '=' NUMBER",
"setitem : K_COMMAND_TIMEOUT",
"setitem : K_COMMAND_TIMEOUT '=' num",
"setitem : K_MAPPING_TIMEOUT",
"setitem : K_MAPPING_TIMEOUT '=' num",
"setitem : K_TM_GMTOFF",
"setitem : K_TM_GMTOFF '=' num",
"setitem : K_SHOW_CURSOR '=' NUMBER",
"setitem : K_SHOW_CURSOR",
"setitem : K_NOSHOW_CURSOR",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 437 "gram.y"
	{
                                  struct roman * roman = session->cur_doc;
                                  struct sheet * sh = roman->cur_sh;
                                  let(roman, sh, yystack.l_mark[-2].rval.left.vp, yystack.l_mark[0].enode);
                                  }
#line 4298 "y.tab.c"
break;
case 2:
#line 444 "gram.y"
	{
                                  /* TODO get this code out of gram.y - reeval cells that depends on $2*/
                                  extern graphADT graph;
                                  struct roman * roman = session->cur_doc;
                                  struct sheet * sh = roman->cur_sh;
#ifdef UNDO
                                  /* here we save in undostruct, all the ents that depends on the deleted one (before change)*/
                                  ents_that_depends_on_range(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col);
                                  create_undo_action();
                                  copy_to_undostruct(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, UNDO_DEL, HANDLE_DEPS, NULL);
#endif

                                  if (getVertex(graph, sh, lookat(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col), 0) != NULL) destroy_vertex(sh, lookat(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col));

                                  yystack.l_mark[-1].rval.left.vp->v = (double) 0.0;
                                  if (yystack.l_mark[-1].rval.left.vp->expr && !(yystack.l_mark[-1].rval.left.vp->flags & is_strexpr)) {
                                      efree(yystack.l_mark[-1].rval.left.vp->expr);
                                      yystack.l_mark[-1].rval.left.vp->expr = NULL;
                                  }
                                  yystack.l_mark[-1].rval.left.vp->cellerror = CELLOK;
                                  yystack.l_mark[-1].rval.left.vp->flags &= ~is_valid;
                                  yystack.l_mark[-1].rval.left.vp->flags |= is_changed;
                                  roman->modflg++;

                                  /* clearing the value counts as a write, so run write triggers*/
                                  if (( yystack.l_mark[-1].rval.left.vp->trigger  ) && ((yystack.l_mark[-1].rval.left.vp->trigger->flag & TRG_WRITE) == TRG_WRITE))
                                      do_trigger(yystack.l_mark[-1].rval.left.vp, TRG_WRITE);

#ifdef UNDO
                                  /* here we save in undostruct, all the ents that depends on the deleted one (after change)*/
                                  copy_to_undostruct(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, UNDO_ADD, HANDLE_DEPS, NULL);
                                  extern struct ent_ptr * deps;
                                  if (deps != NULL) {
                                      free(deps);
                                      deps = NULL;
                                  }
                                  end_undo_action();
#endif
                                  }
#line 4341 "y.tab.c"
break;
case 3:
#line 484 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            slet(roman, sh, yystack.l_mark[-2].rval.left.vp, yystack.l_mark[0].enode, 0);
                                          }
#line 4350 "y.tab.c"
break;
case 4:
#line 490 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            slet(roman, sh, yystack.l_mark[-2].rval.left.vp, yystack.l_mark[0].enode, -1);
                                          }
#line 4359 "y.tab.c"
break;
case 5:
#line 495 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            slet(roman, sh, yystack.l_mark[-2].rval.left.vp, yystack.l_mark[0].enode, 1);
                                          }
#line 4368 "y.tab.c"
break;
case 6:
#line 500 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            ljustify(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4376 "y.tab.c"
break;
case 7:
#line 504 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            rjustify(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4384 "y.tab.c"
break;
case 8:
#line 509 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            center(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4392 "y.tab.c"
break;
case 9:
#line 513 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            format_cell(sh, yystack.l_mark[-1].rval.left.vp, yystack.l_mark[-1].rval.right.vp, yystack.l_mark[0].sval);
                                            scxfree(yystack.l_mark[0].sval);
                                     }
#line 4402 "y.tab.c"
break;
case 10:
#line 520 "gram.y"
	{
                                            struct roman * roman = session->cur_doc;
                                            struct sheet * sh = roman->cur_sh;
                                            dateformat(sh, yystack.l_mark[-1].rval.left.vp, yystack.l_mark[-1].rval.right.vp, yystack.l_mark[0].sval);
                                            scxfree(yystack.l_mark[0].sval);
                                       }
#line 4412 "y.tab.c"
break;
case 11:
#line 526 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       dateformat(sh, lookat(sh, sh->currow, sh->curcol), lookat(sh, sh->currow, sh->curcol), yystack.l_mark[0].sval);
                                       scxfree(yystack.l_mark[0].sval); }
#line 4421 "y.tab.c"
break;
case 12:
#line 532 "gram.y"
	{ hide_col(yystack.l_mark[0].ival, 1); }
#line 4426 "y.tab.c"
break;
case 13:
#line 533 "gram.y"
	{ hide_row(yystack.l_mark[0].ival, 1); }
#line 4431 "y.tab.c"
break;
case 14:
#line 534 "gram.y"
	{ show_col(yystack.l_mark[0].ival, 1); }
#line 4436 "y.tab.c"
break;
case 15:
#line 535 "gram.y"
	{ show_row(yystack.l_mark[0].ival, 1); }
#line 4441 "y.tab.c"
break;
case 16:
#line 538 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       deletecol(sh, yystack.l_mark[0].ival, 1);
                                     }
#line 4450 "y.tab.c"
break;
case 17:
#line 543 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       deleterow(sh, yystack.l_mark[0].ival, 1);
                                     }
#line 4459 "y.tab.c"
break;
case 18:
#line 550 "gram.y"
	{
                                       hide_col(yystack.l_mark[0].ival, 1); }
#line 4465 "y.tab.c"
break;
case 19:
#line 552 "gram.y"
	{
                                       show_col(yystack.l_mark[0].ival, 1); }
#line 4471 "y.tab.c"
break;
case 20:
#line 554 "gram.y"
	{
                                       hide_row(yystack.l_mark[0].ival, 1); }
#line 4477 "y.tab.c"
break;
case 21:
#line 556 "gram.y"
	{
                                       show_row(yystack.l_mark[0].ival, 1); }
#line 4483 "y.tab.c"
break;
case 22:
#line 558 "gram.y"
	{
                                       show_col(yystack.l_mark[-2].ival, yystack.l_mark[0].ival-yystack.l_mark[-2].ival+1); }
#line 4489 "y.tab.c"
break;
case 23:
#line 560 "gram.y"
	{
                                       show_row(yystack.l_mark[-2].ival, yystack.l_mark[0].ival-yystack.l_mark[-2].ival+1); }
#line 4495 "y.tab.c"
break;
case 24:
#line 562 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       int c = sh->curcol, arg;
                                       if (yystack.l_mark[-2].ival < yystack.l_mark[0].ival) {
                                            sh->curcol = yystack.l_mark[-2].ival;
                                            arg = yystack.l_mark[0].ival - yystack.l_mark[-2].ival + 1;
                                       } else {
                                            sh->curcol = yystack.l_mark[0].ival;
                                            arg = yystack.l_mark[-2].ival - yystack.l_mark[0].ival + 1;
                                       }
                                       hide_col(yystack.l_mark[-2].ival, arg);        /* hide de un rango de columnas*/
                                       sh->curcol = c < sh->curcol ? c : c < sh->curcol + arg ? sh->curcol : c - arg;
                                     }
#line 4513 "y.tab.c"
break;
case 25:
#line 576 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       int r = sh->currow, arg;      /* hide de un rango de filas*/
                                       if (yystack.l_mark[-2].ival < yystack.l_mark[0].ival) {
                                           sh->currow = yystack.l_mark[-2].ival;
                                           arg = yystack.l_mark[0].ival - yystack.l_mark[-2].ival + 1;
                                       } else {
                                           sh->currow = yystack.l_mark[0].ival;
                                           arg = yystack.l_mark[-2].ival - yystack.l_mark[0].ival + 1;
                                       }
                                       hide_row(yystack.l_mark[-2].ival, arg);
                                       sh->currow = r < sh->currow ? r : r < sh->currow + arg ? sh->currow : r - arg;
                                     }
#line 4531 "y.tab.c"
break;
case 26:
#line 591 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       valueize_area(sh, 0, 0, sh->maxrow, sh->maxcol); }
#line 4539 "y.tab.c"
break;
case 27:
#line 596 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       if (strlen(yystack.l_mark[0].sval) != 1 || (yystack.l_mark[0].sval[0] != 'h' && yystack.l_mark[0].sval[0] != 'j' && yystack.l_mark[0].sval[0] != 'k' && yystack.l_mark[0].sval[0] != 'l')) {
                                           sc_error("wrong parameter for shift command");
                                       } else {
                                           wchar_t wstr[2] = L"";
                                           swprintf(wstr, BUFFERSIZE, L"%c", yystack.l_mark[0].sval[0]);
                                           shift(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.right.vp->row, yystack.l_mark[-1].rval.right.vp->col, wstr[0]);
                                       }
                                       scxfree(yystack.l_mark[0].sval);
                                     }
#line 4555 "y.tab.c"
break;
case 28:
#line 609 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       set_cell_mark(yystack.l_mark[-1].ival + 97, sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col);
                                     }
#line 4564 "y.tab.c"
break;
case 29:
#line 615 "gram.y"
	{
                                          struct roman * roman = session->cur_doc;
                                          struct sheet * sh = roman->cur_sh;
                                          srange * sr = create_range('\0', '\0', yystack.l_mark[-1].rval.left.vp, yystack.l_mark[0].rval.left.vp);
                                          unselect_ranges();
                                          set_range_mark(yystack.l_mark[-2].ival + 97, sh, sr);
                                     }
#line 4575 "y.tab.c"
break;
case 30:
#line 623 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh;
                                       if ((sh = search_sheet(roman, yystack.l_mark[-1].sval)) != NULL ) {
                                           set_cell_mark(yystack.l_mark[-2].ival + 97, sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col);
                                       }
                                       scxfree(yystack.l_mark[-1].sval);
                                     }
#line 4587 "y.tab.c"
break;
case 31:
#line 632 "gram.y"
	{
                                          struct roman * roman = session->cur_doc;
                                          struct sheet * sh;
                                          if ((sh = search_sheet(roman, yystack.l_mark[-2].sval)) != NULL ) {
                                              srange * sr = create_range('\0', '\0', yystack.l_mark[-1].rval.left.vp, yystack.l_mark[0].rval.left.vp);
                                              unselect_ranges();
                                              set_range_mark(yystack.l_mark[-3].ival + 97, sh, sr);
                                          }
                                          scxfree(yystack.l_mark[-2].sval);
                                     }
#line 4601 "y.tab.c"
break;
case 32:
#line 642 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       fill(sh, yystack.l_mark[-2].rval.left.vp, yystack.l_mark[-2].rval.right.vp, yystack.l_mark[-1].fval, yystack.l_mark[0].fval);
                                     }
#line 4610 "y.tab.c"
break;
case 33:
#line 648 "gram.y"
	{ sc_error("Not enough parameters for fill command"); }
#line 4615 "y.tab.c"
break;
case 34:
#line 650 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, yystack.l_mark[-2].ival, 0), lookat(sh, yystack.l_mark[0].ival, 0), 1, 'r'); }
#line 4623 "y.tab.c"
break;
case 35:
#line 654 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, yystack.l_mark[0].ival, 0), lookat(sh, yystack.l_mark[0].ival, 0), 1, 'r'); }
#line 4631 "y.tab.c"
break;
case 36:
#line 658 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, 0, yystack.l_mark[-2].ival), lookat(sh, 0, yystack.l_mark[0].ival), 1, 'c'); }
#line 4639 "y.tab.c"
break;
case 37:
#line 662 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, 0, yystack.l_mark[0].ival), lookat(sh, 0, yystack.l_mark[0].ival), 1, 'c'); }
#line 4647 "y.tab.c"
break;
case 38:
#line 666 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, yystack.l_mark[-2].ival, 0), lookat(sh, yystack.l_mark[0].ival, 0), 0, 'r'); }
#line 4655 "y.tab.c"
break;
case 39:
#line 670 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, yystack.l_mark[0].ival, 0), lookat(sh, yystack.l_mark[0].ival, 0), 0, 'r'); }
#line 4663 "y.tab.c"
break;
case 40:
#line 674 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, 0, yystack.l_mark[-2].ival), lookat(sh, 0, yystack.l_mark[0].ival), 0, 'c'); }
#line 4671 "y.tab.c"
break;
case 41:
#line 678 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       handle_freeze(sh, lookat(sh, 0, yystack.l_mark[0].ival), lookat(sh, 0, yystack.l_mark[0].ival), 0, 'c'); }
#line 4679 "y.tab.c"
break;
case 42:
#line 683 "gram.y"
	{ sortrange(session->cur_doc->cur_sh, yystack.l_mark[-1].rval.left.vp, yystack.l_mark[-1].rval.right.vp, yystack.l_mark[0].sval);
                                       /*scxfree($3);*/
                                       /*do not free here*/
                                     }
#line 4687 "y.tab.c"
break;
case 43:
#line 687 "gram.y"
	{
                                       subtotal(yystack.l_mark[-3].rval.left.vp->row, yystack.l_mark[-3].rval.left.vp->col, yystack.l_mark[-3].rval.right.vp->row,
                                                yystack.l_mark[-3].rval.right.vp->col, yystack.l_mark[-2].ival, yystack.l_mark[-1].sval, yystack.l_mark[0].ival, 0);
                                       scxfree(yystack.l_mark[-1].sval);
                                     }
#line 4696 "y.tab.c"
break;
case 44:
#line 692 "gram.y"
	{
                                       subtotal(yystack.l_mark[-3].rval.left.vp->row, yystack.l_mark[-3].rval.left.vp->col, yystack.l_mark[-3].rval.right.vp->row,
                                                 yystack.l_mark[-3].rval.right.vp->col, yystack.l_mark[-2].ival, yystack.l_mark[-1].sval, yystack.l_mark[0].ival, 1);
                                       scxfree(yystack.l_mark[-1].sval);
                                     }
#line 4705 "y.tab.c"
break;
case 45:
#line 706 "gram.y"
	{ auto_fit(session->cur_doc->cur_sh, yystack.l_mark[-2].ival, yystack.l_mark[0].ival, DEFWIDTH); }
#line 4710 "y.tab.c"
break;
case 46:
#line 707 "gram.y"
	{ auto_fit(session->cur_doc->cur_sh, yystack.l_mark[0].ival, yystack.l_mark[0].ival, DEFWIDTH); }
#line 4715 "y.tab.c"
break;
case 47:
#line 709 "gram.y"
	{
                                       pad(session->cur_doc->cur_sh, yystack.l_mark[-3].ival, 0, yystack.l_mark[-2].ival, session->cur_doc->cur_sh->maxrow, yystack.l_mark[0].ival); }
#line 4721 "y.tab.c"
break;
case 48:
#line 711 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       pad(sh, yystack.l_mark[-1].ival, 0, yystack.l_mark[0].ival, sh->maxrow, yystack.l_mark[0].ival); }
#line 4729 "y.tab.c"
break;
case 49:
#line 715 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       pad(sh, yystack.l_mark[-1].ival, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4737 "y.tab.c"
break;
case 50:
#line 719 "gram.y"
	{   getformat(yystack.l_mark[0].ival, fdoutput); }
#line 4742 "y.tab.c"
break;
case 51:
#line 720 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       doformat(sh, yystack.l_mark[-3].ival,yystack.l_mark[-3].ival,yystack.l_mark[-2].ival,yystack.l_mark[-1].ival,yystack.l_mark[0].ival);
                                       }
#line 4751 "y.tab.c"
break;
case 52:
#line 725 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       dorowformat(sh, yystack.l_mark[-1].ival, yystack.l_mark[0].ival);
                                     }
#line 4760 "y.tab.c"
break;
case 53:
#line 731 "gram.y"
	{ enable_filters(yystack.l_mark[0].rval.left.vp, yystack.l_mark[0].rval.right.vp);
                                     }
#line 4766 "y.tab.c"
break;
case 54:
#line 733 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       moveto(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.right.vp->row, yystack.l_mark[-1].rval.right.vp->col, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col);
                                     }
#line 4775 "y.tab.c"
break;
case 55:
#line 738 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       moveto(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, -1, -1);
                                 }
#line 4784 "y.tab.c"
break;
case 56:
#line 743 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       num_search(sh, yystack.l_mark[0].fval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 0, 1); }
#line 4792 "y.tab.c"
break;
case 57:
#line 747 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 0, 1); }
#line 4800 "y.tab.c"
break;
case 58:
#line 752 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 1, 1); }
#line 4808 "y.tab.c"
break;
case 59:
#line 757 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 2, 1); }
#line 4816 "y.tab.c"
break;
case 60:
#line 763 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       num_search(sh, yystack.l_mark[0].fval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 0, 0); }
#line 4824 "y.tab.c"
break;
case 61:
#line 768 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 0, 0); }
#line 4832 "y.tab.c"
break;
case 62:
#line 773 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 1, 0); }
#line 4840 "y.tab.c"
break;
case 63:
#line 778 "gram.y"
	{
                                       struct roman * roman = session->cur_doc;
                                       struct sheet * sh = roman->cur_sh;
                                       str_search(sh, yystack.l_mark[0].sval, 0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol, 2, 0); }
#line 4848 "y.tab.c"
break;
case 64:
#line 785 "gram.y"
	{ copy_to_clipboard(yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4853 "y.tab.c"
break;
case 65:
#line 786 "gram.y"
	{ convert_string_to_number(yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col); }
#line 4858 "y.tab.c"
break;
case 66:
#line 787 "gram.y"
	{ paste_from_clipboard(); }
#line 4863 "y.tab.c"
break;
case 67:
#line 788 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   lock_cells(sh, yystack.l_mark[0].rval.left.vp, yystack.l_mark[0].rval.right.vp);
                                 }
#line 4872 "y.tab.c"
break;
case 68:
#line 793 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   unlock_cells(sh, yystack.l_mark[0].rval.left.vp, yystack.l_mark[0].rval.right.vp);
                                 }
#line 4881 "y.tab.c"
break;
case 69:
#line 798 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh;

                                   /* do not need to alloc a new 'Sheet1'*/
                                   /* just reuse the just allocated 'Sheet1' in load_file();*/
                                   if (! strcmp(yystack.l_mark[0].sval, "Sheet1") && (sh = search_sheet(roman, yystack.l_mark[0].sval)) != NULL && sh->flags & is_allocated) {
                                       sh->flags &= ~is_allocated;
                                       sh->flags |= is_empty;
                                       scxfree(yystack.l_mark[0].sval);
                                       chg_mode('.');

                                   /* if a sheet already exists with the name we are trying to create*/
                                   } else if ((sh = search_sheet(roman, yystack.l_mark[0].sval)) != NULL ) {
                                       sc_info("sheet already exist with that name");
                                       scxfree(yystack.l_mark[0].sval);
                                       chg_mode('.');

                                   /* if a just allocated 'Sheet1' exists, reuse it and do not malloc a new one.*/
                                   } else if ((sh = search_sheet(roman, "Sheet1")) != NULL && sh->flags & is_allocated) {
                                       sh->flags &= ~is_allocated;
                                       sh->flags |= is_empty;
                                       free(sh->name);
                                       sh->name = yystack.l_mark[0].sval;
                                       chg_mode('.');
                                       ui_update(TRUE);

                                   /* if reached here, now yes malloc a new one*/
                                   } else {
                                       roman->cur_sh = new_sheet(roman, yystack.l_mark[0].sval);
                                       growtbl(roman->cur_sh, GROWNEW, 0, 0);
                                       erasedb(roman->cur_sh, 0);
                                       scxfree(yystack.l_mark[0].sval);
                                       roman->modflg++;
                                       chg_mode('.');
                                       ui_update(TRUE);
                                   }
                                 }
#line 4923 "y.tab.c"
break;
case 70:
#line 836 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh;
                                   if ((sh = search_sheet(roman, yystack.l_mark[0].sval)) == NULL ) {
                                       sc_info("No sheet exists with that name");
                                       scxfree(yystack.l_mark[0].sval);
                                   } else if (roman->cur_sh == sh && sh->next == NULL && sh->prev == NULL) {
                                       sc_info("Cannot delete the only sheet of document");
                                       scxfree(yystack.l_mark[0].sval);
                                   } else {
                                       if (roman->cur_sh == sh && sh->next != NULL)
                                           roman->cur_sh = sh->next;
                                       else if (roman->cur_sh == sh)
                                           roman->cur_sh = sh->prev;
                                       delete_sheet(roman, sh, 0);
                                       sh = NULL;
                                       roman->modflg++;
                                       scxfree(yystack.l_mark[0].sval);
                                       chg_mode('.');
                                       ui_update(TRUE);
                                   }
                                 }
#line 4949 "y.tab.c"
break;
case 71:
#line 858 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   if (sh->next == NULL && sh->prev == NULL) {
                                       sc_info("Cannot delete the only sheet of document");
                                   } else {
                                       if (roman->cur_sh == sh && sh->next != NULL)
                                           roman->cur_sh = sh->next;
                                       else if (roman->cur_sh == sh)
                                           roman->cur_sh = sh->prev;
                                       delete_sheet(roman, sh, 0);
                                       sh = NULL;
                                       roman->modflg++;
                                       chg_mode('.');
                                       ui_update(TRUE);
                                   }
                                 }
#line 4970 "y.tab.c"
break;
case 72:
#line 875 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   if (roman->cur_sh->next != NULL) {
                                       roman->cur_sh = roman->cur_sh->next;
                                   } else if (roman->next != NULL) {
                                       session->cur_doc = roman->next;
                                       session->cur_doc->cur_sh = session->cur_doc->first_sh;
                                   } else {
                                       session->cur_doc = session->first_doc;
                                       session->cur_doc->cur_sh = session->cur_doc->first_sh;
                                   }
                                   chg_mode('.');
                                   ui_update(TRUE);
                                 }
#line 4988 "y.tab.c"
break;
case 73:
#line 889 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   if (roman->cur_sh->prev != NULL) {
                                       roman->cur_sh = roman->cur_sh->prev;
                                   } else if (roman->prev != NULL) {
                                       session->cur_doc = roman->prev;
                                       session->cur_doc->cur_sh = session->cur_doc->last_sh;
                                   } else {
                                       session->cur_doc = session->last_doc;
                                       session->cur_doc->cur_sh = session->cur_doc->last_sh;
                                   }
                                   chg_mode('.');
                                   ui_update(TRUE);
                                 }
#line 5006 "y.tab.c"
break;
case 74:
#line 904 "gram.y"
	{
                                   struct sheet * sh;
                                   if ((sh = search_sheet(session->cur_doc, yystack.l_mark[0].sval)) != NULL )
                                       session->cur_doc->cur_sh = sh;
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5016 "y.tab.c"
break;
case 75:
#line 910 "gram.y"
	{
                                   struct sheet * sh = session->cur_doc->cur_sh;
                                   if (sh->name != NULL) free(sh->name);
                                   session->cur_doc->modflg++;
                                   sh->name = yystack.l_mark[0].sval;
                                   chg_mode('.');
                                   ui_show_header();
                                 }
#line 5028 "y.tab.c"
break;
case 76:
#line 919 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, NORMAL_MODE, 1);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5037 "y.tab.c"
break;
case 77:
#line 925 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, INSERT_MODE, 1);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5046 "y.tab.c"
break;
case 78:
#line 930 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, EDIT_MODE, 1);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5055 "y.tab.c"
break;
case 79:
#line 935 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, VISUAL_MODE, 1);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5064 "y.tab.c"
break;
case 80:
#line 940 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, COMMAND_MODE, 1);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                 }
#line 5073 "y.tab.c"
break;
case 81:
#line 945 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, NORMAL_MODE, 0);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5082 "y.tab.c"
break;
case 82:
#line 951 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, INSERT_MODE, 0);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5091 "y.tab.c"
break;
case 83:
#line 956 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, EDIT_MODE, 0);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5100 "y.tab.c"
break;
case 84:
#line 961 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, VISUAL_MODE, 0);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5109 "y.tab.c"
break;
case 85:
#line 966 "gram.y"
	{
                                   add_map(yystack.l_mark[-1].sval, yystack.l_mark[0].sval, COMMAND_MODE, 0);
                                   scxfree(yystack.l_mark[-1].sval);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5118 "y.tab.c"
break;
case 86:
#line 972 "gram.y"
	{
                                   del_map(yystack.l_mark[0].sval, NORMAL_MODE);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5126 "y.tab.c"
break;
case 87:
#line 977 "gram.y"
	{
                                   del_map(yystack.l_mark[0].sval, INSERT_MODE);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5134 "y.tab.c"
break;
case 88:
#line 981 "gram.y"
	{
                                   del_map(yystack.l_mark[0].sval, EDIT_MODE);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5142 "y.tab.c"
break;
case 89:
#line 985 "gram.y"
	{
                                   del_map(yystack.l_mark[0].sval, VISUAL_MODE);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5150 "y.tab.c"
break;
case 90:
#line 990 "gram.y"
	{
                                   del_map(yystack.l_mark[0].sval, COMMAND_MODE);
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5158 "y.tab.c"
break;
case 91:
#line 994 "gram.y"
	{
#ifdef USECOLORS
                                   chg_color(yystack.l_mark[0].sval);
#endif
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5168 "y.tab.c"
break;
case 92:
#line 1001 "gram.y"
	{
                                   char det[BUFFERSIZE] = "";
                                   struct ent * e = yystack.l_mark[0].ent.vp;

                                   sprintf(det + strlen(det), "row: %d\n", e->row);
                                   sprintf(det + strlen(det), "col: %d\n", e->col);
                                   sprintf(det + strlen(det), "cellerror: %d\n"   , e->cellerror);
                                   sprintf(det + strlen(det), "flags:\n");
                                   sprintf(det + strlen(det), "is_valid: %d\n"    , e->flags & is_valid );
                                   sprintf(det + strlen(det), "is_deleted: %d\n"  , e->flags & is_deleted);
                                   sprintf(det + strlen(det), "is_changed: %d\n"  , e->flags & is_changed);
                                   sprintf(det + strlen(det), "is_strexpr: %d\n"  , e->flags & is_strexpr);
                                   sprintf(det + strlen(det), "is_leftflush: %d\n", e->flags & is_leftflush);
                                   sprintf(det + strlen(det), "is_locked: %d\n"   , e->flags & is_locked);
                                   sprintf(det + strlen(det), "is_label: %d\n"    , e->flags & is_label);
                                   sprintf(det + strlen(det), "iscleared: %d\n"   , e->flags & iscleared);
                                   sprintf(det + strlen(det), "may_sync: %d\n"    , e->flags & may_sync);
                                   ui_show_text((char *) &det);
                                   }
#line 5191 "y.tab.c"
break;
case 93:
#line 1022 "gram.y"
	{
#ifdef USECOLORS
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   if ( ! get_conf_int("nocurses"))
                                       color_cell(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.right.vp->row, yystack.l_mark[-1].rval.right.vp->col, yystack.l_mark[0].sval);
#endif
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5204 "y.tab.c"
break;
case 94:
#line 1032 "gram.y"
	{
                                          set_trigger(session->cur_doc->cur_sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.right.vp->row, yystack.l_mark[-1].rval.right.vp->col, yystack.l_mark[0].sval);
                                          scxfree(yystack.l_mark[0].sval);
                                        }
#line 5212 "y.tab.c"
break;
case 95:
#line 1037 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->offscr_sc_cols = yystack.l_mark[0].ival;
                                 }
#line 5221 "y.tab.c"
break;
case 96:
#line 1042 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->offscr_sc_rows = yystack.l_mark[0].ival;
                                 }
#line 5230 "y.tab.c"
break;
case 97:
#line 1047 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->nb_frozen_rows = yystack.l_mark[0].ival;
                                 }
#line 5239 "y.tab.c"
break;
case 98:
#line 1052 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->nb_frozen_cols = yystack.l_mark[0].ival;
                                 }
#line 5248 "y.tab.c"
break;
case 99:
#line 1057 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->nb_frozen_screenrows = yystack.l_mark[0].ival;
                                 }
#line 5257 "y.tab.c"
break;
case 100:
#line 1062 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
                                   sh->nb_frozen_screencols = yystack.l_mark[0].ival;
                                 }
#line 5266 "y.tab.c"
break;
case 101:
#line 1068 "gram.y"
	{
                                   del_trigger(session->cur_doc->cur_sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col);
                                   }
#line 5273 "y.tab.c"
break;
case 102:
#line 1072 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
#ifdef USECOLORS
                                   if ( ! get_conf_int("nocurses"))
                                       color_cell(sh, sh->currow, sh->curcol, sh->currow, sh->curcol, yystack.l_mark[0].sval);
#endif
                                   scxfree(yystack.l_mark[0].sval);
                                   }
#line 5286 "y.tab.c"
break;
case 103:
#line 1082 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
#ifdef USECOLORS
                                   if ( ! get_conf_int("nocurses")) unformat(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col);
#endif
                                   }
#line 5297 "y.tab.c"
break;
case 104:
#line 1090 "gram.y"
	{
                                   struct roman * roman = session->cur_doc;
                                   struct sheet * sh = roman->cur_sh;
#ifdef USECOLORS
                                   if ( ! get_conf_int("nocurses")) unformat(sh, sh->currow, sh->curcol, sh->currow, sh->curcol);
#endif
                                   }
#line 5308 "y.tab.c"
break;
case 105:
#line 1098 "gram.y"
	{
                                         redefine_color(yystack.l_mark[-3].sval, yystack.l_mark[-2].ival, yystack.l_mark[-1].ival, yystack.l_mark[0].ival);
                                         scxfree(yystack.l_mark[-3].sval); }
#line 5315 "y.tab.c"
break;
case 106:
#line 1102 "gram.y"
	{
                                         define_color(yystack.l_mark[-3].sval, yystack.l_mark[-2].ival, yystack.l_mark[-1].ival, yystack.l_mark[0].ival);
                                         scxfree(yystack.l_mark[-3].sval); }
#line 5322 "y.tab.c"
break;
case 107:
#line 1106 "gram.y"
	{ fcopy(session->cur_doc->cur_sh, ""); }
#line 5327 "y.tab.c"
break;
case 108:
#line 1107 "gram.y"
	{ fcopy(session->cur_doc->cur_sh, yystack.l_mark[0].sval); }
#line 5332 "y.tab.c"
break;
case 109:
#line 1108 "gram.y"
	{ fsum(session->cur_doc->cur_sh);  }
#line 5337 "y.tab.c"
break;
case 110:
#line 1110 "gram.y"
	{
                                     plot(yystack.l_mark[-1].sval, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col);
                                     scxfree(yystack.l_mark[-1].sval);
                                   }
#line 5345 "y.tab.c"
break;
case 111:
#line 1118 "gram.y"
	{ /*if (! loading) sc_debug("INT: Config value changed");*/
                                   }
#line 5351 "y.tab.c"
break;
case 112:
#line 1134 "gram.y"
	{ add_range(yystack.l_mark[-1].sval, yystack.l_mark[0].rval.left, yystack.l_mark[0].rval.right, 1); }
#line 5356 "y.tab.c"
break;
case 113:
#line 1135 "gram.y"
	{ add_range(yystack.l_mark[-1].sval, yystack.l_mark[0].ent, yystack.l_mark[0].ent, 0); }
#line 5361 "y.tab.c"
break;
case 114:
#line 1137 "gram.y"
	{ del_range(yystack.l_mark[0].rval.left.vp, yystack.l_mark[0].rval.right.vp); }
#line 5366 "y.tab.c"
break;
case 115:
#line 1139 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh = roman->cur_sh;
                                     eval_result = eval(sh, NULL, yystack.l_mark[0].enode, 0);
                                     efree(yystack.l_mark[0].enode);
                                   }
#line 5376 "y.tab.c"
break;
case 116:
#line 1145 "gram.y"
	{

                                     inputline[0]=L'\0';

                                     #ifdef HISTORY_FILE
                                            commandline_history = (struct history *) create_history(':');
                                            load_history(commandline_history, ':'); /* load the command history file*/
                                     #endif
                                     #ifdef INS_HISTORY_FILE
                                            insert_history = (struct history *) create_history('=');
                                            load_history(insert_history, '='); /* load the insert history file*/
                                     #endif

                                     (void) swprintf(inputline, BUFFERSIZE, L"%s", yystack.l_mark[0].sval);

                                     struct block * auxb = (struct block *) create_buf();
                                     addto_buf(auxb, OKEY_ENTER);
                                     do_commandmode(auxb);
                                     flush_buf(auxb);
                                     erase_buf(auxb);
                                     auxb = NULL;
                                     inputline[0]=L'\0';
                                     scxfree(yystack.l_mark[0].sval);
                                   }
#line 5404 "y.tab.c"
break;
case 117:
#line 1169 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     swprintf(inputline, BUFFERSIZE, L"e! %s %s", yystack.l_mark[-1].sval, yystack.l_mark[0].sval);
                                     do_export(0, 0, roman->cur_sh->maxrow, roman->cur_sh->maxcol);
                                     scxfree(yystack.l_mark[-1].sval);
                                     scxfree(yystack.l_mark[0].sval);
                                   }
#line 5415 "y.tab.c"
break;
case 118:
#line 1176 "gram.y"
	{
                                     printf("quitting. unsaved changes will be lost.\n");
                                     shall_quit = 2; /* unsaved changes are lost!*/
                                   }
#line 5423 "y.tab.c"
break;
case 119:
#line 1180 "gram.y"
	{
                                     rebuild_graph();
                                     ui_update(FALSE);
                                   }
#line 5431 "y.tab.c"
break;
case 120:
#line 1185 "gram.y"
	{ print_vertexs(); }
#line 5436 "y.tab.c"
break;
case 121:
#line 1186 "gram.y"
	{ sync_refs(session->cur_doc->cur_sh); }
#line 5441 "y.tab.c"
break;
case 122:
#line 1188 "gram.y"
	{
#ifdef UNDO
                                     do_undo();
                                     /* sync_refs(session->cur_doc->cur_sh);*/
                                     EvalAll();
                                     ui_update(TRUE);
#endif
                                   }
#line 5453 "y.tab.c"
break;
case 123:
#line 1197 "gram.y"
	{
#ifdef UNDO
                                     do_redo();
                                     /* sync_refs(session->cur_doc->cur_sh);*/
                                     EvalAll();
                                     ui_update(TRUE);
#endif
                                   }
#line 5465 "y.tab.c"
break;
case 124:
#line 1207 "gram.y"
	{
                                     EvalAll();
                                     /*ui_update(1);*/
                                     /*changed = 0;*/
                                   }
#line 5474 "y.tab.c"
break;
case 125:
#line 1212 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh = roman->cur_sh;
                                     getnum(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, fdoutput);
                                   }
#line 5483 "y.tab.c"
break;
case 126:
#line 1218 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh;
                                     if ((sh = search_sheet(roman, yystack.l_mark[-3].sval)) == NULL )
                                         sh = roman->cur_sh;
                                     getnum(sh, yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, fdoutput);
                                     scxfree(yystack.l_mark[-3].sval);
                                   }
#line 5495 "y.tab.c"
break;
case 127:
#line 1226 "gram.y"
	{ getstring(yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, fdoutput); }
#line 5500 "y.tab.c"
break;
case 128:
#line 1228 "gram.y"
	{ getexp(yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, fdoutput); }
#line 5505 "y.tab.c"
break;
case 129:
#line 1231 "gram.y"
	{ getfmt(yystack.l_mark[0].rval.left.vp->row, yystack.l_mark[0].rval.left.vp->col, yystack.l_mark[0].rval.right.vp->row, yystack.l_mark[0].rval.right.vp->col, fdoutput); }
#line 5510 "y.tab.c"
break;
case 130:
#line 1233 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh;
                                     if ((sh = search_sheet(roman, yystack.l_mark[-4].sval)) == NULL )
                                         sh = roman->cur_sh;
                                     yank_area(sh, yystack.l_mark[-1].rval.left.vp->row, yystack.l_mark[-1].rval.left.vp->col, yystack.l_mark[-1].rval.right.vp->row, yystack.l_mark[-1].rval.right.vp->col, yystack.l_mark[0].sval[0], 1);
                                     scxfree(yystack.l_mark[-4].sval);
                                     scxfree(yystack.l_mark[0].sval);
                                   }
#line 5523 "y.tab.c"
break;
case 131:
#line 1242 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh;
                                     if ((sh = search_sheet(roman, yystack.l_mark[-3].sval)) == NULL )
                                         sh = roman->cur_sh;
                                     paste_yanked_ents(sh, yystack.l_mark[-1].ival, yystack.l_mark[0].sval[0]);
                                     scxfree(yystack.l_mark[-3].sval);
                                     scxfree(yystack.l_mark[0].sval);
                                   }
#line 5536 "y.tab.c"
break;
case 132:
#line 1251 "gram.y"
	{
                                     struct roman * roman = session->cur_doc;
                                     struct sheet * sh = roman->cur_sh;
                                     seval_result = seval(sh, NULL, yystack.l_mark[0].enode, 0); /* always make sure this seval_result is always freed afterwards*/
                                     efree(yystack.l_mark[0].enode);
                                   }
#line 5546 "y.tab.c"
break;
case 133:
#line 1257 "gram.y"
	{ sc_error(yystack.l_mark[0].sval);
                                     /*free $2*/
                                   }
#line 5553 "y.tab.c"
break;
case 135:
#line 1262 "gram.y"
	{
                     sc_error("syntax error: %s", line);
                     YYABORT;

                     /*linelim = 0;*/
                     /*yyparse();*/

                     /*line[0]='\0';*/
                     /*linelim = -1;*/
                     /*yyclearin;*/
                     /*yyerrok;*/
                 }
#line 5569 "y.tab.c"
break;
case 136:
#line 1275 "gram.y"
	{
                                    if (yystack.l_mark[0].ent.vf & GET_ENT)
                                        yyval.enode = yystack.l_mark[0].ent.expr;
                                    else {
                                       yystack.l_mark[0].ent.sheet = NULL;
                                       yyval.enode = new_var(O_VAR, yystack.l_mark[0].ent);
                                       yyval.enode->e.r.left.expr = NULL;
                                       yyval.enode->e.r.right.expr = NULL;
                                    }
                                  }
#line 5583 "y.tab.c"
break;
case 137:
#line 1286 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    struct sheet * sh;
                                    if ((sh = search_sheet(roman, yystack.l_mark[-3].sval)) != NULL) {
                                        struct ent_ptr ep;
                                        ep.vf = yystack.l_mark[0].ent.vf;
                                        ep.vp = lookat(sh, yystack.l_mark[0].ent.vp->row, yystack.l_mark[0].ent.vp->col);
                                        ep.sheet = sh;
                                        yyval.enode = new_var(O_VAR, ep);
                                        yyval.enode->e.r.left.expr = NULL;
                                        yyval.enode->e.r.right.expr = NULL;
                                        scxfree(yystack.l_mark[-3].sval);
                                    } else {
                                        /*sc_debug("not sheet found");*/
                                        yyval.enode = NULL;
                                        scxfree(yystack.l_mark[-3].sval);
                                    }
                                  }
#line 5605 "y.tab.c"
break;
case 138:
#line 1305 "gram.y"
	{ yyval.enode = new('f', yystack.l_mark[0].enode, ENULL); }
#line 5610 "y.tab.c"
break;
case 139:
#line 1308 "gram.y"
	{ yyval.enode = new('F', yystack.l_mark[0].enode, ENULL); }
#line 5615 "y.tab.c"
break;
case 140:
#line 1311 "gram.y"
	{ yyval.enode = new(SUM, new_range(REDUCE | SUM, yystack.l_mark[-1].rval), ENULL); }
#line 5620 "y.tab.c"
break;
case 141:
#line 1313 "gram.y"
	{ yyval.enode = new(SUM, new_range(REDUCE | SUM, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5625 "y.tab.c"
break;
case 142:
#line 1315 "gram.y"
	{ yyval.enode = new(PROD, new_range(REDUCE | PROD, yystack.l_mark[-1].rval), ENULL); }
#line 5630 "y.tab.c"
break;
case 143:
#line 1317 "gram.y"
	{ yyval.enode = new(PROD, new_range(REDUCE | PROD, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5635 "y.tab.c"
break;
case 144:
#line 1319 "gram.y"
	{ yyval.enode = new(AVG, new_range(REDUCE | AVG, yystack.l_mark[-1].rval), ENULL); }
#line 5640 "y.tab.c"
break;
case 145:
#line 1321 "gram.y"
	{ yyval.enode = new(AVG, new_range(REDUCE | AVG, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5645 "y.tab.c"
break;
case 146:
#line 1323 "gram.y"
	{ yyval.enode = new(STDDEV, new_range(REDUCE | STDDEV, yystack.l_mark[-1].rval), ENULL); }
#line 5650 "y.tab.c"
break;
case 147:
#line 1325 "gram.y"
	{ yyval.enode = new(STDDEV, new_range(REDUCE | STDDEV, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5655 "y.tab.c"
break;
case 148:
#line 1327 "gram.y"
	{ yyval.enode = new(COUNT, new_range(REDUCE | COUNT, yystack.l_mark[-1].rval), ENULL); }
#line 5660 "y.tab.c"
break;
case 149:
#line 1329 "gram.y"
	{ yyval.enode = new(COUNT, new_range(REDUCE | COUNT, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5665 "y.tab.c"
break;
case 150:
#line 1331 "gram.y"
	{ yyval.enode = new(MAX, new_range(REDUCE | MAX, yystack.l_mark[-1].rval), ENULL); }
#line 5670 "y.tab.c"
break;
case 151:
#line 1333 "gram.y"
	{ yyval.enode = new(MAX, new_range(REDUCE | MAX, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5675 "y.tab.c"
break;
case 152:
#line 1335 "gram.y"
	{ yyval.enode = new(LMAX, yystack.l_mark[-1].enode, yystack.l_mark[-3].enode); }
#line 5680 "y.tab.c"
break;
case 153:
#line 1337 "gram.y"
	{ yyval.enode = new(MIN, new_range(REDUCE | MIN, yystack.l_mark[-1].rval), ENULL); }
#line 5685 "y.tab.c"
break;
case 154:
#line 1339 "gram.y"
	{ yyval.enode = new(MIN, new_range(REDUCE | MIN, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5690 "y.tab.c"
break;
case 155:
#line 1341 "gram.y"
	{ yyval.enode = new(LMIN, yystack.l_mark[-1].enode, yystack.l_mark[-3].enode); }
#line 5695 "y.tab.c"
break;
case 156:
#line 1343 "gram.y"
	{ yyval.enode = new_range(REDUCE | 'R', yystack.l_mark[-1].rval); }
#line 5700 "y.tab.c"
break;
case 157:
#line 1345 "gram.y"
	{ yyval.enode = new_range(REDUCE | 'C', yystack.l_mark[-1].rval); }
#line 5705 "y.tab.c"
break;
case 158:
#line 1346 "gram.y"
	{ yyval.enode = new(ABS, yystack.l_mark[-1].enode, ENULL); }
#line 5710 "y.tab.c"
break;
case 159:
#line 1347 "gram.y"
	{ yyval.enode = new(FROW, yystack.l_mark[-1].enode, ENULL); }
#line 5715 "y.tab.c"
break;
case 160:
#line 1348 "gram.y"
	{ yyval.enode = new(FCOL, yystack.l_mark[-1].enode, ENULL); }
#line 5720 "y.tab.c"
break;
case 161:
#line 1349 "gram.y"
	{ yyval.enode = new(ACOS, yystack.l_mark[-1].enode, ENULL); }
#line 5725 "y.tab.c"
break;
case 162:
#line 1350 "gram.y"
	{ yyval.enode = new(ASIN, yystack.l_mark[-1].enode, ENULL); }
#line 5730 "y.tab.c"
break;
case 163:
#line 1351 "gram.y"
	{ yyval.enode = new(ATAN, yystack.l_mark[-1].enode, ENULL); }
#line 5735 "y.tab.c"
break;
case 164:
#line 1353 "gram.y"
	{ yyval.enode = new(ATAN2, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5740 "y.tab.c"
break;
case 165:
#line 1354 "gram.y"
	{ yyval.enode = new(CEIL, yystack.l_mark[-1].enode, ENULL); }
#line 5745 "y.tab.c"
break;
case 166:
#line 1355 "gram.y"
	{ yyval.enode = new(COS, yystack.l_mark[-1].enode, ENULL); }
#line 5750 "y.tab.c"
break;
case 167:
#line 1356 "gram.y"
	{ yyval.enode = new(EXP, yystack.l_mark[-1].enode, ENULL); }
#line 5755 "y.tab.c"
break;
case 168:
#line 1357 "gram.y"
	{ yyval.enode = new(FABS, yystack.l_mark[-1].enode, ENULL); }
#line 5760 "y.tab.c"
break;
case 169:
#line 1358 "gram.y"
	{ yyval.enode = new(FLOOR, yystack.l_mark[-1].enode, ENULL); }
#line 5765 "y.tab.c"
break;
case 170:
#line 1360 "gram.y"
	{ yyval.enode = new(HYPOT, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5770 "y.tab.c"
break;
case 171:
#line 1361 "gram.y"
	{ yyval.enode = new(LOG, yystack.l_mark[-1].enode, ENULL); }
#line 5775 "y.tab.c"
break;
case 172:
#line 1362 "gram.y"
	{ yyval.enode = new(LOG10, yystack.l_mark[-1].enode, ENULL); }
#line 5780 "y.tab.c"
break;
case 173:
#line 1364 "gram.y"
	{ yyval.enode = new(POW, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5785 "y.tab.c"
break;
case 174:
#line 1365 "gram.y"
	{ yyval.enode = new(SIN, yystack.l_mark[-1].enode, ENULL); }
#line 5790 "y.tab.c"
break;
case 175:
#line 1366 "gram.y"
	{ yyval.enode = new(SQRT, yystack.l_mark[-1].enode, ENULL); }
#line 5795 "y.tab.c"
break;
case 176:
#line 1367 "gram.y"
	{ yyval.enode = new(TAN, yystack.l_mark[-1].enode, ENULL); }
#line 5800 "y.tab.c"
break;
case 177:
#line 1368 "gram.y"
	{ yyval.enode = new(DTR, yystack.l_mark[-1].enode, ENULL); }
#line 5805 "y.tab.c"
break;
case 178:
#line 1369 "gram.y"
	{ yyval.enode = new(RTD, yystack.l_mark[-1].enode, ENULL); }
#line 5810 "y.tab.c"
break;
case 179:
#line 1370 "gram.y"
	{ yyval.enode = new(RND, yystack.l_mark[-1].enode, ENULL); }
#line 5815 "y.tab.c"
break;
case 180:
#line 1372 "gram.y"
	{ yyval.enode = new(ROUND, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5820 "y.tab.c"
break;
case 181:
#line 1374 "gram.y"
	{ yyval.enode = new(IF,  yystack.l_mark[-5].enode,new(',',yystack.l_mark[-3].enode,yystack.l_mark[-1].enode)); }
#line 5825 "y.tab.c"
break;
case 182:
#line 1376 "gram.y"
	{ yyval.enode = new(PV,  yystack.l_mark[-5].enode,new(':',yystack.l_mark[-3].enode,yystack.l_mark[-1].enode)); }
#line 5830 "y.tab.c"
break;
case 183:
#line 1378 "gram.y"
	{ yyval.enode = new(FV,  yystack.l_mark[-5].enode,new(':',yystack.l_mark[-3].enode,yystack.l_mark[-1].enode)); }
#line 5835 "y.tab.c"
break;
case 184:
#line 1380 "gram.y"
	{ yyval.enode = new(PMT, yystack.l_mark[-5].enode,new(':',yystack.l_mark[-3].enode,yystack.l_mark[-1].enode)); }
#line 5840 "y.tab.c"
break;
case 185:
#line 1381 "gram.y"
	{ yyval.enode = new(HOUR, yystack.l_mark[-1].enode, ENULL); }
#line 5845 "y.tab.c"
break;
case 186:
#line 1382 "gram.y"
	{ yyval.enode = new(MINUTE, yystack.l_mark[-1].enode, ENULL); }
#line 5850 "y.tab.c"
break;
case 187:
#line 1383 "gram.y"
	{ yyval.enode = new(SECOND, yystack.l_mark[-1].enode, ENULL); }
#line 5855 "y.tab.c"
break;
case 188:
#line 1384 "gram.y"
	{ yyval.enode = new(MONTH, yystack.l_mark[-1].enode, ENULL); }
#line 5860 "y.tab.c"
break;
case 189:
#line 1385 "gram.y"
	{ yyval.enode = new(DAY, yystack.l_mark[-1].enode, ENULL); }
#line 5865 "y.tab.c"
break;
case 190:
#line 1386 "gram.y"
	{ yyval.enode = new(YEAR, yystack.l_mark[-1].enode, ENULL); }
#line 5870 "y.tab.c"
break;
case 191:
#line 1387 "gram.y"
	{ yyval.enode = new(NOW, ENULL, ENULL);}
#line 5875 "y.tab.c"
break;
case 192:
#line 1389 "gram.y"
	{ yyval.enode = new(DTS, yystack.l_mark[-5].enode, new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode));}
#line 5880 "y.tab.c"
break;
case 193:
#line 1391 "gram.y"
	{ yyval.enode = new(DTS, new_const(O_CONST, (double) yystack.l_mark[-4].ival),
                                         new(',', new_const(O_CONST, (double) yystack.l_mark[-2].ival),
                                         new_const(O_CONST, (double) yystack.l_mark[0].ival)));}
#line 5887 "y.tab.c"
break;
case 194:
#line 1395 "gram.y"
	{ yyval.enode = new(TTS, yystack.l_mark[-5].enode, new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode));}
#line 5892 "y.tab.c"
break;
case 195:
#line 1396 "gram.y"
	{ yyval.enode = new(STON, yystack.l_mark[-1].enode, ENULL); }
#line 5897 "y.tab.c"
break;
case 196:
#line 1397 "gram.y"
	{ yyval.enode = new(SLEN, yystack.l_mark[-1].enode, ENULL); }
#line 5902 "y.tab.c"
break;
case 197:
#line 1399 "gram.y"
	{ yyval.enode = new(EQS, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5907 "y.tab.c"
break;
case 198:
#line 1400 "gram.y"
	{ yyval.enode = new(DATE, yystack.l_mark[-1].enode, ENULL); }
#line 5912 "y.tab.c"
break;
case 199:
#line 1402 "gram.y"
	{ yyval.enode = new(DATE, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5917 "y.tab.c"
break;
case 200:
#line 1404 "gram.y"
	{ yyval.enode = new(FMT, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 5922 "y.tab.c"
break;
case 201:
#line 1405 "gram.y"
	{ yyval.enode = new(UPPER, yystack.l_mark[-1].enode, ENULL); }
#line 5927 "y.tab.c"
break;
case 202:
#line 1406 "gram.y"
	{ yyval.enode = new(LOWER, yystack.l_mark[-1].enode, ENULL); }
#line 5932 "y.tab.c"
break;
case 203:
#line 1407 "gram.y"
	{ yyval.enode = new(CAPITAL, yystack.l_mark[-1].enode, ENULL); }
#line 5937 "y.tab.c"
break;
case 204:
#line 1409 "gram.y"
	{ yyval.enode = new(INDEX, new_range(REDUCE | INDEX, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5942 "y.tab.c"
break;
case 205:
#line 1411 "gram.y"
	{ yyval.enode = new(INDEX, new_range(REDUCE | INDEX, yystack.l_mark[-1].rval), yystack.l_mark[-3].enode); }
#line 5947 "y.tab.c"
break;
case 206:
#line 1413 "gram.y"
	{ yyval.enode = new(INDEX, new_range(REDUCE | INDEX, yystack.l_mark[-5].rval), new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 5952 "y.tab.c"
break;
case 207:
#line 1415 "gram.y"
	{ yyval.enode = new(LOOKUP, new_range(REDUCE | LOOKUP, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5957 "y.tab.c"
break;
case 208:
#line 1417 "gram.y"
	{ yyval.enode = new(LOOKUP, new_range(REDUCE | LOOKUP, yystack.l_mark[-1].rval), yystack.l_mark[-3].enode); }
#line 5962 "y.tab.c"
break;
case 209:
#line 1419 "gram.y"
	{ yyval.enode = new(HLOOKUP, new_range(REDUCE | HLOOKUP, yystack.l_mark[-5].rval), new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 5967 "y.tab.c"
break;
case 210:
#line 1421 "gram.y"
	{ yyval.enode = new(HLOOKUP, new_range(REDUCE | HLOOKUP, yystack.l_mark[-3].rval), new(',', yystack.l_mark[-5].enode, yystack.l_mark[-1].enode)); }
#line 5972 "y.tab.c"
break;
case 211:
#line 1423 "gram.y"
	{ yyval.enode = new(VLOOKUP, new_range(REDUCE | VLOOKUP, yystack.l_mark[-5].rval), new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 5977 "y.tab.c"
break;
case 212:
#line 1425 "gram.y"
	{ yyval.enode = new(VLOOKUP, new_range(REDUCE | VLOOKUP, yystack.l_mark[-3].rval), new(',', yystack.l_mark[-5].enode, yystack.l_mark[-1].enode)); }
#line 5982 "y.tab.c"
break;
case 213:
#line 1427 "gram.y"
	{ yyval.enode = new(STINDEX, new_range(REDUCE | STINDEX, yystack.l_mark[-3].rval), yystack.l_mark[-1].enode); }
#line 5987 "y.tab.c"
break;
case 214:
#line 1429 "gram.y"
	{ yyval.enode = new(STINDEX, new_range(REDUCE | STINDEX, yystack.l_mark[-1].rval), yystack.l_mark[-3].enode); }
#line 5992 "y.tab.c"
break;
case 215:
#line 1431 "gram.y"
	{ yyval.enode = new(STINDEX, new_range(REDUCE | STINDEX, yystack.l_mark[-5].rval), new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 5997 "y.tab.c"
break;
case 216:
#line 1433 "gram.y"
	{ yyval.enode = new(EXT, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 6002 "y.tab.c"
break;
case 217:
#line 1435 "gram.y"
	{
                                  #ifdef XLUA
                                  yyval.enode = new(LUA, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode);
                                  #endif
                                  }
#line 6011 "y.tab.c"
break;
case 218:
#line 1440 "gram.y"
	{ yyval.enode = new(MYROW, ENULL, ENULL);}
#line 6016 "y.tab.c"
break;
case 219:
#line 1441 "gram.y"
	{ yyval.enode = new(MYCOL, ENULL, ENULL);}
#line 6021 "y.tab.c"
break;
case 220:
#line 1442 "gram.y"
	{ yyval.enode = new(LASTROW, ENULL, ENULL);}
#line 6026 "y.tab.c"
break;
case 221:
#line 1443 "gram.y"
	{ yyval.enode = new(LASTCOL, ENULL, ENULL);}
#line 6031 "y.tab.c"
break;
case 222:
#line 1445 "gram.y"
	{ yyval.enode = new(NVAL, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 6036 "y.tab.c"
break;
case 223:
#line 1447 "gram.y"
	{ yyval.enode = new(SVAL, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode); }
#line 6041 "y.tab.c"
break;
case 224:
#line 1449 "gram.y"
	{ yyval.enode = new(REPLACE, yystack.l_mark[-5].enode, new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 6046 "y.tab.c"
break;
case 225:
#line 1451 "gram.y"
	{ yyval.enode = new(EVALUATE, yystack.l_mark[-1].enode, ENULL); }
#line 6051 "y.tab.c"
break;
case 226:
#line 1452 "gram.y"
	{ yyval.enode = new(SEVALUATE, yystack.l_mark[-1].enode, ENULL); }
#line 6056 "y.tab.c"
break;
case 227:
#line 1454 "gram.y"
	{ yyval.enode = new(SUBSTR, yystack.l_mark[-5].enode, new(',', yystack.l_mark[-3].enode, yystack.l_mark[-1].enode)); }
#line 6061 "y.tab.c"
break;
case 228:
#line 1455 "gram.y"
	{ yyval.enode = yystack.l_mark[-1].enode; }
#line 6066 "y.tab.c"
break;
case 229:
#line 1456 "gram.y"
	{ yyval.enode = yystack.l_mark[0].enode; }
#line 6071 "y.tab.c"
break;
case 230:
#line 1458 "gram.y"
	{ yyval.enode = new_const(O_CONST, (double) yystack.l_mark[0].ival); }
#line 6076 "y.tab.c"
break;
case 231:
#line 1459 "gram.y"
	{ yyval.enode = new_const(O_CONST, yystack.l_mark[0].fval); }
#line 6081 "y.tab.c"
break;
case 232:
#line 1460 "gram.y"
	{ yyval.enode = new(PI_, ENULL, ENULL); }
#line 6086 "y.tab.c"
break;
case 233:
#line 1461 "gram.y"
	{ yyval.enode = new_str(yystack.l_mark[0].sval); }
#line 6091 "y.tab.c"
break;
case 234:
#line 1462 "gram.y"
	{ yyval.enode = new('!', yystack.l_mark[0].enode, ENULL); }
#line 6096 "y.tab.c"
break;
case 235:
#line 1463 "gram.y"
	{ yyval.enode = new('!', yystack.l_mark[0].enode, ENULL); }
#line 6101 "y.tab.c"
break;
case 236:
#line 1465 "gram.y"
	{ yyval.enode = new(FILENAME, yystack.l_mark[-1].enode, ENULL); }
#line 6106 "y.tab.c"
break;
case 237:
#line 1466 "gram.y"
	{ yyval.enode = new(COLTOA, yystack.l_mark[-1].enode, ENULL);}
#line 6111 "y.tab.c"
break;
case 238:
#line 1467 "gram.y"
	{ yyval.enode = new(ASCII, yystack.l_mark[-1].enode, ENULL); }
#line 6116 "y.tab.c"
break;
case 239:
#line 1468 "gram.y"
	{ yyval.enode = new(SET8BIT, yystack.l_mark[-1].enode, ENULL); }
#line 6121 "y.tab.c"
break;
case 240:
#line 1469 "gram.y"
	{ yyval.enode = new(CHR, yystack.l_mark[-1].enode, ENULL);}
#line 6126 "y.tab.c"
break;
case 241:
#line 1470 "gram.y"
	{ yyval.enode = new(ERR_, ENULL, ENULL); }
#line 6131 "y.tab.c"
break;
case 242:
#line 1471 "gram.y"
	{ yyval.enode = new(ERR_, ENULL, ENULL); }
#line 6136 "y.tab.c"
break;
case 243:
#line 1472 "gram.y"
	{ yyval.enode = new(REF_, ENULL, ENULL); }
#line 6141 "y.tab.c"
break;
case 244:
#line 1473 "gram.y"
	{ yyval.enode = new(REF_, ENULL, ENULL); }
#line 6146 "y.tab.c"
break;
case 245:
#line 1474 "gram.y"
	{ yyval.enode = new(FACT, yystack.l_mark[-1].enode, ENULL); }
#line 6151 "y.tab.c"
break;
case 246:
#line 1478 "gram.y"
	{ yyval.enode = new('+', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6156 "y.tab.c"
break;
case 247:
#line 1479 "gram.y"
	{ yyval.enode = new('-', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6161 "y.tab.c"
break;
case 248:
#line 1480 "gram.y"
	{ yyval.enode = new('*', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6166 "y.tab.c"
break;
case 249:
#line 1481 "gram.y"
	{ yyval.enode = new('/', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6171 "y.tab.c"
break;
case 250:
#line 1482 "gram.y"
	{ yyval.enode = new('%', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6176 "y.tab.c"
break;
case 251:
#line 1483 "gram.y"
	{ yyval.enode = new('m', yystack.l_mark[0].enode, ENULL); }
#line 6181 "y.tab.c"
break;
case 252:
#line 1484 "gram.y"
	{ yyval.enode = new('^', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6186 "y.tab.c"
break;
case 254:
#line 1486 "gram.y"
	{ yyval.enode = new('?', yystack.l_mark[-4].enode, new(':', yystack.l_mark[-2].enode, yystack.l_mark[0].enode)); }
#line 6191 "y.tab.c"
break;
case 255:
#line 1487 "gram.y"
	{ yyval.enode = new(';', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6196 "y.tab.c"
break;
case 256:
#line 1488 "gram.y"
	{ yyval.enode = new('<', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6201 "y.tab.c"
break;
case 257:
#line 1489 "gram.y"
	{ yyval.enode = new('=', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6206 "y.tab.c"
break;
case 258:
#line 1490 "gram.y"
	{ yyval.enode = new('>', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6211 "y.tab.c"
break;
case 259:
#line 1491 "gram.y"
	{ yyval.enode = new('&', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6216 "y.tab.c"
break;
case 260:
#line 1492 "gram.y"
	{ yyval.enode = new('|', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6221 "y.tab.c"
break;
case 261:
#line 1493 "gram.y"
	{ yyval.enode = new('!', new('>', yystack.l_mark[-3].enode, yystack.l_mark[0].enode), ENULL); }
#line 6226 "y.tab.c"
break;
case 262:
#line 1495 "gram.y"
	{ yyval.enode = new('!', new('=', yystack.l_mark[-3].enode, yystack.l_mark[0].enode), ENULL); }
#line 6231 "y.tab.c"
break;
case 263:
#line 1496 "gram.y"
	{ yyval.enode = new('!', new('<', yystack.l_mark[-3].enode, yystack.l_mark[0].enode), ENULL); }
#line 6236 "y.tab.c"
break;
case 264:
#line 1497 "gram.y"
	{ yyval.enode = new('#', yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6241 "y.tab.c"
break;
case 265:
#line 1500 "gram.y"
	{ yyval.enode = new(ELIST, ENULL, yystack.l_mark[0].enode); }
#line 6246 "y.tab.c"
break;
case 266:
#line 1501 "gram.y"
	{ yyval.enode = new(ELIST, yystack.l_mark[-2].enode, yystack.l_mark[0].enode); }
#line 6251 "y.tab.c"
break;
case 267:
#line 1504 "gram.y"
	{
                                    yyval.rval.left = yystack.l_mark[-2].ent;
                                    yyval.rval.right = yystack.l_mark[0].ent;
                                  }
#line 6259 "y.tab.c"
break;
case 268:
#line 1508 "gram.y"
	{ yyval.rval = yystack.l_mark[0].rval; }
#line 6264 "y.tab.c"
break;
case 269:
#line 1513 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    yyval.ent.vp = lookat(roman->cur_sh, yystack.l_mark[0].ival, yystack.l_mark[-1].ival);
                                    yyval.ent.vf = 0;
                                  }
#line 6273 "y.tab.c"
break;
case 270:
#line 1518 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    yyval.ent.vp = lookat(roman->cur_sh, yystack.l_mark[0].ival, yystack.l_mark[-1].ival);
                                    yyval.ent.vf = FIX_COL;
                                  }
#line 6282 "y.tab.c"
break;
case 271:
#line 1523 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    yyval.ent.vp = lookat(roman->cur_sh, yystack.l_mark[0].ival, yystack.l_mark[-2].ival);
                                    yyval.ent.vf = FIX_ROW;
                                  }
#line 6291 "y.tab.c"
break;
case 272:
#line 1528 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    yyval.ent.vp = lookat(roman->cur_sh, yystack.l_mark[0].ival, yystack.l_mark[-2].ival);
                                    yyval.ent.vf = FIX_ROW | FIX_COL;
                                  }
#line 6300 "y.tab.c"
break;
case 273:
#line 1535 "gram.y"
	{
                                    struct roman * roman = session->cur_doc;
                                    struct sheet * sh = roman->cur_sh;
                                    yyval.ent.vp = lookat(sh, eval(sh, NULL, yystack.l_mark[-3].enode, 0), eval(sh, NULL, yystack.l_mark[-1].enode, 0));
                                    yyval.ent.vf = GET_ENT;
                                    if (yyval.ent.expr != NULL) efree(yyval.ent.expr);
                                    yyval.ent.expr = new(GETENT, yystack.l_mark[-3].enode, yystack.l_mark[-1].enode);
                                  }
#line 6312 "y.tab.c"
break;
case 274:
#line 1544 "gram.y"
	{
                                    yyval.ent = yystack.l_mark[0].rval.left;
                                  }
#line 6319 "y.tab.c"
break;
case 275:
#line 1550 "gram.y"
	{ yyval.rval = yystack.l_mark[0].rval; }
#line 6324 "y.tab.c"
break;
case 276:
#line 1551 "gram.y"
	{ yyval.rval.left = yystack.l_mark[0].ent; yyval.rval.right = yystack.l_mark[0].ent; }
#line 6329 "y.tab.c"
break;
case 277:
#line 1554 "gram.y"
	{ yyval.fval = (double) yystack.l_mark[0].ival; }
#line 6334 "y.tab.c"
break;
case 278:
#line 1555 "gram.y"
	{ yyval.fval = yystack.l_mark[0].fval; }
#line 6339 "y.tab.c"
break;
case 279:
#line 1556 "gram.y"
	{ yyval.fval = -yystack.l_mark[0].fval; }
#line 6344 "y.tab.c"
break;
case 280:
#line 1557 "gram.y"
	{ yyval.fval = yystack.l_mark[0].fval; }
#line 6349 "y.tab.c"
break;
case 281:
#line 1560 "gram.y"
	{ yyval.sval = yystack.l_mark[0].sval; }
#line 6354 "y.tab.c"
break;
case 282:
#line 1561 "gram.y"
	{
                                    char *s, *s1;
                                    s1 = yystack.l_mark[0].ent.vp->label;
                                    if (!s1)
                                    s1 = "NULL_STRING";
                                    s = scxmalloc((unsigned)strlen(s1)+1);
                                    (void) strcpy(s, s1);
                                    yyval.sval = s;
                                  }
#line 6367 "y.tab.c"
break;
case 285:
#line 1579 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "overlap=0", TRUE);
                                     else         parse_str(user_conf_d, "overlap=1", TRUE); }
#line 6373 "y.tab.c"
break;
case 286:
#line 1581 "gram.y"
	{               parse_str(user_conf_d, "overlap=1", TRUE); }
#line 6378 "y.tab.c"
break;
case 287:
#line 1582 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "input_bar_bottom=0", TRUE);
                                     else         parse_str(user_conf_d, "input_bar_bottom=1", TRUE);
                                                  ui_mv_bottom_bar(); }
#line 6385 "y.tab.c"
break;
case 288:
#line 1585 "gram.y"
	{               parse_str(user_conf_d, "input_bar_bottom=1", TRUE);
                                                  ui_mv_bottom_bar();
                                  }
#line 6392 "y.tab.c"
break;
case 289:
#line 1589 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "input_edit_mode=0", TRUE);
                                     else         parse_str(user_conf_d, "input_edit_mode=1", TRUE);
                                                  ui_mv_bottom_bar(); }
#line 6399 "y.tab.c"
break;
case 290:
#line 1592 "gram.y"
	{               parse_str(user_conf_d, "input_edit_mode=1", TRUE);
                                                  ui_mv_bottom_bar();
                                  }
#line 6406 "y.tab.c"
break;
case 291:
#line 1596 "gram.y"
	{            if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "underline_grid=0", TRUE);
                                                  else parse_str(user_conf_d, "underline_grid=1", TRUE); }
#line 6412 "y.tab.c"
break;
case 292:
#line 1598 "gram.y"
	{               parse_str(user_conf_d, "underline_grid=1", TRUE);
                                  }
#line 6418 "y.tab.c"
break;
case 293:
#line 1601 "gram.y"
	{               parse_str(user_conf_d, "overlap=0", TRUE); }
#line 6423 "y.tab.c"
break;
case 294:
#line 1603 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "truncate=0", TRUE);
                                     else         parse_str(user_conf_d, "truncate=1", TRUE); }
#line 6429 "y.tab.c"
break;
case 295:
#line 1605 "gram.y"
	{               parse_str(user_conf_d, "truncate=1", TRUE); }
#line 6434 "y.tab.c"
break;
case 296:
#line 1606 "gram.y"
	{               parse_str(user_conf_d, "truncate=0", TRUE); }
#line 6439 "y.tab.c"
break;
case 297:
#line 1608 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "autowrap=0", TRUE);
                                     else         parse_str(user_conf_d, "autowrap=1", TRUE); }
#line 6445 "y.tab.c"
break;
case 298:
#line 1610 "gram.y"
	{               parse_str(user_conf_d, "autowrap=1", TRUE); }
#line 6450 "y.tab.c"
break;
case 299:
#line 1611 "gram.y"
	{               parse_str(user_conf_d, "autowrap=0", TRUE); }
#line 6455 "y.tab.c"
break;
case 300:
#line 1613 "gram.y"
	{
                                                  char cmd[MAXCMD];
                                                  sprintf(cmd, "autobackup=%d", yystack.l_mark[0].ival);
                                                  parse_str(user_conf_d, cmd, TRUE); }
#line 6463 "y.tab.c"
break;
case 301:
#line 1617 "gram.y"
	{               parse_str(user_conf_d, "autobackup=0", TRUE); }
#line 6468 "y.tab.c"
break;
case 302:
#line 1618 "gram.y"
	{               parse_str(user_conf_d, "autocalc=1", TRUE); }
#line 6473 "y.tab.c"
break;
case 303:
#line 1619 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "autocalc=0", TRUE);
                                     else         parse_str(user_conf_d, "autocalc=1", TRUE); }
#line 6479 "y.tab.c"
break;
case 304:
#line 1621 "gram.y"
	{               parse_str(user_conf_d, "autocalc=0", TRUE); }
#line 6484 "y.tab.c"
break;
case 305:
#line 1622 "gram.y"
	{               parse_str(user_conf_d, "debug=1", TRUE); }
#line 6489 "y.tab.c"
break;
case 306:
#line 1623 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "debug=0", TRUE);
                                     else         parse_str(user_conf_d, "debug=1", TRUE); }
#line 6495 "y.tab.c"
break;
case 307:
#line 1625 "gram.y"
	{               parse_str(user_conf_d, "debug=0", TRUE); }
#line 6500 "y.tab.c"
break;
case 308:
#line 1626 "gram.y"
	{               parse_str(user_conf_d, "trigger=1", TRUE); }
#line 6505 "y.tab.c"
break;
case 309:
#line 1627 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "trigger=0", TRUE);
                                     else         parse_str(user_conf_d, "trigger=1", TRUE); }
#line 6511 "y.tab.c"
break;
case 310:
#line 1629 "gram.y"
	{               parse_str(user_conf_d, "trigger=0", TRUE); }
#line 6516 "y.tab.c"
break;
case 311:
#line 1630 "gram.y"
	{               parse_str(user_conf_d, "external_functions=1", TRUE); }
#line 6521 "y.tab.c"
break;
case 312:
#line 1631 "gram.y"
	{
                                     if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "external_functions=0", TRUE);
                                     else         parse_str(user_conf_d, "external_functions=1", TRUE); }
#line 6528 "y.tab.c"
break;
case 313:
#line 1634 "gram.y"
	{               parse_str(user_conf_d, "external_functions=0", TRUE); }
#line 6533 "y.tab.c"
break;
case 314:
#line 1635 "gram.y"
	{               parse_str(user_conf_d, "exec_lua=1", TRUE); }
#line 6538 "y.tab.c"
break;
case 315:
#line 1636 "gram.y"
	{
                                     if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "exec_lua=0", TRUE);
                                     else         parse_str(user_conf_d, "exec_lua=1", TRUE); }
#line 6545 "y.tab.c"
break;
case 316:
#line 1639 "gram.y"
	{               parse_str(user_conf_d, "exec_lua=0", TRUE); }
#line 6550 "y.tab.c"
break;
case 317:
#line 1640 "gram.y"
	{               parse_str(user_conf_d, "half_page_scroll=1", TRUE); }
#line 6555 "y.tab.c"
break;
case 318:
#line 1642 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "half_page_scroll=0", TRUE);
                                     else         parse_str(user_conf_d, "half_page_scroll=1", TRUE); }
#line 6561 "y.tab.c"
break;
case 319:
#line 1644 "gram.y"
	{               parse_str(user_conf_d, "half_page_scroll=0", TRUE); }
#line 6566 "y.tab.c"
break;
case 320:
#line 1646 "gram.y"
	{               parse_str(user_conf_d, "ignore_hidden=1", TRUE); }
#line 6571 "y.tab.c"
break;
case 321:
#line 1648 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "ignore_hidden=0", TRUE);
                                     else         parse_str(user_conf_d, "ignore_hidden=1", TRUE); }
#line 6577 "y.tab.c"
break;
case 322:
#line 1650 "gram.y"
	{               parse_str(user_conf_d, "ignore_hidden=0", TRUE); }
#line 6582 "y.tab.c"
break;
case 323:
#line 1652 "gram.y"
	{
                                     if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "quiet=0", TRUE);
                                     else         parse_str(user_conf_d, "quiet=1", TRUE); }
#line 6589 "y.tab.c"
break;
case 324:
#line 1655 "gram.y"
	{               parse_str(user_conf_d, "quiet=1", TRUE); }
#line 6594 "y.tab.c"
break;
case 325:
#line 1656 "gram.y"
	{               parse_str(user_conf_d, "quiet=0", TRUE); }
#line 6599 "y.tab.c"
break;
case 326:
#line 1657 "gram.y"
	{               parse_str(user_conf_d, "quit_afterload=1", TRUE); }
#line 6604 "y.tab.c"
break;
case 327:
#line 1659 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "quit_afterload=0", TRUE);
                                     else         parse_str(user_conf_d, "quit_afterload=1", TRUE); }
#line 6610 "y.tab.c"
break;
case 328:
#line 1661 "gram.y"
	{               parse_str(user_conf_d, "quit_afterload=0", TRUE); }
#line 6615 "y.tab.c"
break;
case 329:
#line 1662 "gram.y"
	{               parse_str(user_conf_d, "xlsx_readformulas=1", TRUE); }
#line 6620 "y.tab.c"
break;
case 330:
#line 1664 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "xlsx_readformulas=0", TRUE);
                                     else         parse_str(user_conf_d, "xlsx_readformulas=1", TRUE); }
#line 6626 "y.tab.c"
break;
case 331:
#line 1666 "gram.y"
	{               parse_str(user_conf_d, "xlsx_readformulas=0", TRUE); }
#line 6631 "y.tab.c"
break;
case 332:
#line 1667 "gram.y"
	{  if (! session->cur_doc->loading) parse_str(user_conf_d, "nocurses=1", TRUE); }
#line 6636 "y.tab.c"
break;
case 333:
#line 1668 "gram.y"
	{  if (! session->cur_doc->loading) {
                                         if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "nocurses=0", TRUE);
                                         else         parse_str(user_conf_d, "nocurses=1", TRUE); }
                                     }
#line 6644 "y.tab.c"
break;
case 334:
#line 1672 "gram.y"
	{  if (! session->cur_doc->loading) parse_str(user_conf_d, "nocurses=0", TRUE); }
#line 6649 "y.tab.c"
break;
case 335:
#line 1673 "gram.y"
	{               parse_str(user_conf_d, "numeric=1", TRUE); }
#line 6654 "y.tab.c"
break;
case 336:
#line 1674 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "numeric=0", TRUE);
                                     else         parse_str(user_conf_d, "numeric=1", TRUE); }
#line 6660 "y.tab.c"
break;
case 337:
#line 1676 "gram.y"
	{               parse_str(user_conf_d, "numeric=0", TRUE); }
#line 6665 "y.tab.c"
break;
case 338:
#line 1677 "gram.y"
	{               parse_str(user_conf_d, "ignorecase=1", TRUE); }
#line 6670 "y.tab.c"
break;
case 339:
#line 1678 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "ignorecase=0", TRUE);
                                     else         parse_str(user_conf_d, "ignorecase=1", TRUE); }
#line 6676 "y.tab.c"
break;
case 340:
#line 1680 "gram.y"
	{               parse_str(user_conf_d, "ignorecase=0", TRUE); }
#line 6681 "y.tab.c"
break;
case 341:
#line 1681 "gram.y"
	{               parse_str(user_conf_d, "numeric_decimal=1", TRUE); }
#line 6686 "y.tab.c"
break;
case 342:
#line 1683 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "numeric_decimal=0", TRUE);
                                     else         parse_str(user_conf_d, "numeric_decimal=1", TRUE); }
#line 6692 "y.tab.c"
break;
case 343:
#line 1685 "gram.y"
	{               parse_str(user_conf_d, "numeric_decimal=0", TRUE); }
#line 6697 "y.tab.c"
break;
case 344:
#line 1686 "gram.y"
	{               parse_str(user_conf_d, "numeric_zero=1", TRUE); }
#line 6702 "y.tab.c"
break;
case 345:
#line 1688 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "numeric_zero=0", TRUE);
                                     else         parse_str(user_conf_d, "numeric_zero=1", TRUE); }
#line 6708 "y.tab.c"
break;
case 346:
#line 1690 "gram.y"
	{               parse_str(user_conf_d, "numeric_zero=0", TRUE); }
#line 6713 "y.tab.c"
break;
case 347:
#line 1691 "gram.y"
	{               parse_str(user_conf_d, "newline_action=0", TRUE); }
#line 6718 "y.tab.c"
break;
case 348:
#line 1692 "gram.y"
	{
                                  char * s = (char *) yystack.l_mark[0].sval;
                                  if (s[0] =='j') parse_str(user_conf_d, "newline_action=j", TRUE);
                                  else if (s[0] =='l')
                                  parse_str(user_conf_d, "newline_action=l", TRUE);
                                  }
#line 6728 "y.tab.c"
break;
case 349:
#line 1698 "gram.y"
	{
                                  char cmd[MAXCMD];
                                  char * s = (char *) yystack.l_mark[0].sval;
                                  sprintf(cmd, "default_copy_to_clipboard_cmd=%s", s);
                                  parse_str(user_conf_d, cmd, FALSE);
                                  scxfree(s);
                                  }
#line 6739 "y.tab.c"
break;
case 350:
#line 1705 "gram.y"
	{
                                  char cmd[MAXCMD];
                                  char * s = (char *) yystack.l_mark[0].sval;
                                  sprintf(cmd, "default_paste_from_clipboard_cmd=%s", s);
                                  parse_str(user_conf_d, cmd, FALSE);
                                  scxfree(s);
                                  }
#line 6750 "y.tab.c"
break;
case 351:
#line 1713 "gram.y"
	{      parse_str(user_conf_d, "import_delimited_to_text=1", TRUE); }
#line 6755 "y.tab.c"
break;
case 352:
#line 1716 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "import_delimited_to_text=0", TRUE);
                                     else         parse_str(user_conf_d, "import_delimited_to_text=1", TRUE); }
#line 6761 "y.tab.c"
break;
case 353:
#line 1719 "gram.y"
	{      parse_str(user_conf_d, "copy_to_clipboard_delimited_tab=1", TRUE); }
#line 6766 "y.tab.c"
break;
case 354:
#line 1722 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "copy_to_clipboard_delimited_tab=0", TRUE);
                                     else         parse_str(user_conf_d, "copy_to_clipboard_delimited_tab=1", TRUE); }
#line 6772 "y.tab.c"
break;
case 355:
#line 1724 "gram.y"
	{    parse_str(user_conf_d, "copy_to_clipboard_delimited_tab=0", TRUE); }
#line 6777 "y.tab.c"
break;
case 356:
#line 1725 "gram.y"
	{            parse_str(user_conf_d, "copy_to_clipboard_wysiwyg=1", TRUE); }
#line 6782 "y.tab.c"
break;
case 357:
#line 1727 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "copy_to_clipboard_wysiwyg=0", TRUE);
                                     else         parse_str(user_conf_d, "copy_to_clipboard_wysiwyg=1", TRUE); }
#line 6788 "y.tab.c"
break;
case 358:
#line 1729 "gram.y"
	{          parse_str(user_conf_d, "copy_to_clipboard_wysiwyg=0", TRUE); }
#line 6793 "y.tab.c"
break;
case 359:
#line 1730 "gram.y"
	{
                                  char cmd[MAXCMD];
                                  char * s = (char *) yystack.l_mark[0].sval;
                                  sprintf(cmd, "default_open_file_under_cursor_cmd=%s", s);
                                  parse_str(user_conf_d, cmd, FALSE);
                                  scxfree(s);
                                  }
#line 6804 "y.tab.c"
break;
case 360:
#line 1738 "gram.y"
	{
                                     if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "newline_action=0", TRUE); }
#line 6810 "y.tab.c"
break;
case 361:
#line 1740 "gram.y"
	{               parse_str(user_conf_d, "command_timeout=3000", TRUE); }
#line 6815 "y.tab.c"
break;
case 362:
#line 1741 "gram.y"
	{
                                     char * s = scxmalloc((unsigned) BUFFERSIZE);
                                     sprintf(s, "command_timeout=%d", (int) yystack.l_mark[0].fval);
                                     parse_str(user_conf_d, s, TRUE);
                                     scxfree(s);
                                     }
#line 6825 "y.tab.c"
break;
case 363:
#line 1747 "gram.y"
	{               parse_str(user_conf_d, "mapping_timeout=1500", TRUE); }
#line 6830 "y.tab.c"
break;
case 364:
#line 1748 "gram.y"
	{
                                     char * s = scxmalloc((unsigned) BUFFERSIZE);
                                     sprintf(s, "mapping_timeout=%d", (int) yystack.l_mark[0].fval);
                                     parse_str(user_conf_d, s, TRUE);
                                     scxfree(s);
                                     }
#line 6840 "y.tab.c"
break;
case 365:
#line 1754 "gram.y"
	{               parse_str(user_conf_d, "tm_gmtoff=-10800", TRUE); }
#line 6845 "y.tab.c"
break;
case 366:
#line 1755 "gram.y"
	{
                                     char * s = scxmalloc((unsigned) BUFFERSIZE);
                                     sprintf(s, "tm_gmtoff=%d", (int) yystack.l_mark[0].fval);
                                     parse_str(user_conf_d, s, TRUE);
                                     scxfree(s);
                                  }
#line 6855 "y.tab.c"
break;
case 367:
#line 1761 "gram.y"
	{  if (yystack.l_mark[0].ival == 0) parse_str(user_conf_d, "show_cursor=0", TRUE);
                                     else         parse_str(user_conf_d, "show_cursor=1", TRUE); }
#line 6861 "y.tab.c"
break;
case 368:
#line 1763 "gram.y"
	{               parse_str(user_conf_d, "show_cursor=1", TRUE); }
#line 6866 "y.tab.c"
break;
case 369:
#line 1764 "gram.y"
	{               parse_str(user_conf_d, "show_cursor=0", TRUE); }
#line 6871 "y.tab.c"
break;
#line 6873 "y.tab.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
